-- **In-Match Tutorial**

Using "ImpInTheCrowd"
Using "ImpInTheCrowdLoops"
Using "ImpFlag_J_"

DisplayedHints = DisplayedHints or { }
OnAnyLoad
{
	function( triggerArgs )
		PersistVariable({ Name = "DisplayedHints" })

		smallId = 190000
		mediumId = 20001
		largeId = 190001
	end
}

function ShowHint( hint, hintDuration )

	if Contains(DisplayedHints, hint) then
		return
	end
	table.insert(DisplayedHints, hint)

	if hintDuration == nil then
		hintDuration = 3
	end

	if GetConfigOptionValue({ Name = "UseMouse" }) then
		displayHint = hint.."_Mouse"
	else
		displayHint = hint.."_Gamepad"
	end

	local displayHelptext = GetDisplayName({ Text = displayHint })
	DisplayInfoPanelText({ Name = displayHelptext, Duration = hintDuration })
end

-- Intro Match Scripts
OnTriggerFired{ "CheckIntroMatchTutorial",

	function(triggerArgs)

		if firstMatchOccurred or matchesPlayed > 0 then
			return
		end

		if pvPreviousMap ~= "Campaign" then
			return
		end

		firstMatchOccurred = true
		PersistVariable({ Name = "firstMatchOccurred" })

		firstMatch = true
		noEnemies = true
		SetMenuOptions({ Name = "InGameUI", Properties = { Run = "HideTeamBPortraits" } })

		DisableInput({ PlayerIndex = 1 })
		DisableInput({ PlayerIndex = 2 })
		thread(ShowInputDisabledPresentation)

		SetConfigOption({ Name = "PlayerTwoAI", Value = false })

		disableMatchCamera = true
		blockFancyCamera = true

		SetFlagTrue({ Name = "FirstMatchTutorial" })

		ToggleControl({ Names = {"Pass", "Cast", "Jump", "Sprint", "AutoLock"}, Enabled = false })

		--PanCamera({ Id = ballId, Duration = 0.6, EaseIn = 0.1, EaseOut = 0.3, Delay = 1.2 })
		--FocusCamera({ ZoomType = "Overshoot", Fraction = currentTutorialZoom * 1.2, Duration = 0.45, Delay = 1.2 })

		wait(0.5)
		PlayMatchDialogue( "tutorialstart" )

		wait(2.2)

		--LockCamera({ Ids = { 40001, ballId }, Duration = 2, DynamicZoom = true })
		local currentTutorialZoom = GetCameraZoom({ })
		PanCamera({ Ids = { 40001, ballId }, Duration = 2, EaseIn = 0.3, EaseOut = 1 })
		--FocusCamera({ ZoomType = "Ease", Fraction = currentTutorialZoom * 1.1, Duration = 0.3, Delay = 1.5 })

		--DisplayInfoPanelText({ Name = "Info_GetBall" })
		thread( PlayIntroMatchSpeech, "theball" )
		DisplayObjective("GetBallTutorial")

		SwitchActiveUnit({ Id = 20001, PlayerIndex = 1 })
		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)
		firstBallHintAllowed = true
		CreateCameraWalls({ OffsetX = 100, OffsetY = 200 })

		--PlayOverheadAnimation({ Name = "ArrowIndicator3", DestinationId = ballId })

		--wait(3)
		wait(2.5)

		-- LockCamera({ Ids = { 190001, ballId }, Duration = 2, DynamicZoom = true })
		PanCamera({ Ids = { 190001, ballId }, Duration = 2, EaseIn = 0.3, EaseOut = 0.6 })
		DestroyAreaWalls({ Delay = 2.1 })
		CreateCameraWalls({ OffsetX = 100, OffsetY = 100, Delay = 2.1 })
		preFirstScoreTutorialAnchor = 40001
	end
}

-- this needs to be above the next OnUsed
OnUsed{ "Token",
	RequiredFlag = "GetBallTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("GetBallTutorial")
	end
}

OnUsed
{ "Token",
	RequiredFlag = "FirstMatchTutorial",
	function(triggerArgs)
		if not firstBallHintAllowed then
			return
		end

		firstBallHintAllowed = false

		DisableInput({ PlayerIndex = 1 })
		thread(ShowInputDisabledPresentation)

		PanCamera({ Ids = { 190001, ballId }, Duration = 1, EaseIn = 0.1, EaseOut = 0.6, Retarget = true })

		wait(1.3)

		--LockCamera({ Ids = { 20001, 190001 }, Duration = 2, DynamicZoom = true })
		local currentTutorialZoom = GetCameraZoom({ })
		PanCamera({ Ids = { 40001 }, Duration = 2, EaseIn = 0.2, EaseOut = 1 })
		DestroyAreaWalls({  })
		CreateCameraWalls({ OffsetX = 100, OffsetY = 100, Delay = 2.05 })

		StopAnimation({ Name = "ArrowIndicator3", DestinationId = ballId })

	--	FireWeapon({ Name = "InvisibleStun", DestinationId = 190001 })
		SetUnitProperty({ Name = "LegalPassTarget", Value = false, DestinationId = 190001 })

		thread( PlayIntroMatchSpeech, "passedtheball" )

		if GetConfigOptionValue({ Name = "UseMouse" }) then
			--DisplayInfoPanelText({ Name = "Info_PassBall_Mouse", Duration = 3 })
			DisplayObjective( "PassTutorial" )
		else
			--DisplayInfoPanelText({ Name = "Info_PassBall_Gamepad", Duration = 3 })
			DisplayObjective( "PassTutorial" )
		end

		wait(0.05)
		ToggleControl({ Name = "Pass", Enabled = true })
		firstPassCompleteAllowed = true
		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)
	end
}

OnActiveUnitChanged
{
	RequiredFlag = "PassHoldTutorial",
	function(triggerArgs)
		DisableInput({ PlayerIndex = 1 })

		wait(0.35)
		local unitData = GetCharacterTableByObjectId( BallCarrierId )
	--	FireWeapon({ Name = "InvisibleStunClear", DestinationId = 190001 })

		-- hold pass interlude
		if unitData["Archetype"] == "PlayerSmall" then
			holdPassTaught = true
			thread(ShowInputDisabledPresentation)

			local currentTutorialZoom = GetCameraZoom({ })
			PanCamera({ Id = ballId, Duration = 0.7, EaseIn = 0.1, EaseOut = 0.4 })
			FocusCamera({ Fraction = currentTutorialZoom * 1.15, Duration = 0.7, ZoomType = "Ease" })

			MarkObjectiveComplete("PassHoldTutorial")
			SetFlagFalse({ Name = "PassHoldTutorial" })
			thread( PlayIntroMatchSpeech, "oneatatime" )
			wait(1.0)
			DisplayInfoPanelText({ Name = "Info_OneUnitActs", Duration = 3.85 })
			thread(PassToEachUnit)
			wait(4)
			--FireTrigger({ Name = "EnemyPyreTutorial" })
			FireTrigger({ Name = "CheckMovementHint" })
		elseif not holdPassTaught then
			EnableInput({ PlayerIndex = 1 })
			DisplayInfoPanelText({ Name = "Info_AimPass", Duration = 1.1 })
		end
	end
}

function PassToEachUnit()
	local currentSmallUnit = GetActiveUnitId({ PlayerIndex = 1 })

	wait(1)
	PanCamera({ Id = 20001, Duration = 0.8, EaseIn = 0.1, EaseOut = 0.4 })
	SwitchActiveUnit({ Id = 20001, PlayerIndex = 1 })
	wait(1)
	PanCamera({ Id = 190000, Duration = 0.8, EaseIn = 0.1, EaseOut = 0.4 })
	SwitchActiveUnit({ Id = 190000, PlayerIndex = 1 })
	wait(1.25)
	PanCamera({ Id = 190001, Duration = 0.8, EaseIn = 0.1, EaseOut = 0.4 })
	SwitchActiveUnit({ Id = 190001, PlayerIndex = 1 })
end

OnTriggerFired
{
	"EnemyPyreTutorial",
	--RequiredFlag = "FirstMatchTutorial",
	function(triggerArgs)
		DisableInput({ PlayerIndex = 1 })
		DestroyCameraWalls({  })
		thread(ShowInputDisabledPresentation)
		wait(0.5)

		local currentTutorialZoom = GetCameraZoom({ })
		PanCamera({ Ids = { goalB, ballId}, Duration = 2, EaseIn = 0.2, EaseOut = 1 })
		FocusCamera({ Fraction = currentTutorialZoom * 0.85, Duration = 0.3, ZoomType = "Overshoot" })
		thread( PlayIntroMatchSpeech, "thepyre" )
		DisplayObjective( "GoalsTutorial" )
		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)

		wait(2)

		if not matchAside then -- focus camera better if you haven't scored (had issues with rest of tutorial)
			DynamicZoomCamera({ Enabled = true, Speed = 0.01 })
			FocusCamera({ Fraction = GetCameraDynamicZoom({ }), Duration = 1, ZoomType = "Ease" })
		end

		wait(2.3)
		SetFlagTrue({ Name = "CheckMovementHint" })


	end
}

OnTriggerFired
{ "CheckMovementHint",
	function(triggerArgs)
		SetFlagFalse({ Name = "CheckMovementHint" })
		DestroyCameraWalls({  })

		PanCamera({ Id = 40001, Duration = 1.0, EaseIn = 0.05, EaseOut = 0.1 })
		local currentTutorialZoom = GetCameraZoom({ })
		FocusCamera({ Fraction = currentTutorialZoom * 0.88, Duration = 1.0, ZoomType = "Overshoot" })

		wait(1.05)
		CreateCameraWalls({ OffsetX = 100, OffsetY = 100 })

		thread(HideInputDisabledPresentation)
		EnableInput({ PlayerIndex = 1 })
		thread(ShowMatchUI)
		initialUIShown = true
		ToggleControl({ Names = { "Sprint" }, Enabled = true })
		DisplayObjective( "SprintTutorial" )
		wait(0.4)
		thread(ShowControlsUITutorial)
		wait(3.6)
	end
}

function BeginRivalTeamIntroduction()

	if postScoreTutorial then
		return
	end

	DynamicZoomCamera({ Enabled = false, Speed = 0.01 })

	postScoreTutorial = true
	PersistVariable({ Name = "postScoreTutorial" })

	DisableInput({ PlayerIndex = 1 })
	DisableInput({ PlayerIndex = 2 })
	thread(ShowInputDisabledPresentation)

	blockMatchInputReEnable = true

	wait(1.5)

	--LockCamera({ Ids = { 40002, 310022 }, Duration = 1.5, DynamicZoom = true })
	PanCamera({ Ids = { 40002, 310022 }, Duration = 2 })


--	DisplayInfoPanelText({ Name = "Info_Rivals", Duration = 1.8 }) -- 2/1 REMOVAL

	wait(1.7)

	--Teleport({ Name = "TeamB", OffsetX = -5000, UseCurrentLocation = true })
	BeamInEntrance( TeamBObjectIds )
	noEnemies = false
	SetMenuOptions({ Name = "InGameUI", Properties = { Run = "ShowTeamBPortraits" } })

	DisableInput({ PlayerIndex = 1 })
	DisableInput({ PlayerIndex = 2 })

	ToggleControl({ Names = { "Cast" }, Enabled = false })
	ToggleControl({ Names = { "AutoLock" }, Enabled = false })
	ToggleControl({ Names = { "Pass" }, Enabled = false })

	--wait(1)
	wait(0.25)

	thread( PlayIntroMatchSpeech, "rivalsappear" )

	ShowEveryoneAndTurnOnTheirAuras()

	wait(0.25)

	PanCamera({ Id = 20108, Duration = 3, EaseIn = 0.1, EaseOut = 1 })

	while true do
		if GetDistance({ Id = 20108, DestinationId = ballId }) < 80 then
			EnableInput({ PlayerIndex = 2 })
			break
		else
			DisableInput({ PlayerIndex = 2 })
			Move({ Id = 20108, DestinationId = ballId, Mode = "Precise" })
			wait(0.1)
		end
	end
	wait(0.01)
	DisableInput({ PlayerIndex = 2 })

	wait(1.5)

	blockMatchInputReEnable = false
	midMatchEventLive = false
	FireTrigger({ Name = "EnemyAlive" })

end

function ShowEveryoneAndTurnOnTheirAuras()
	wait(1)
	preAuraSequenceZoom = GetCameraZoom({ })
	for k, v in pairs(TeamBObjectIds) do
		ShowcaseUnitAndTheirAura(v)
	end
	wait(1)
	for k, v in pairs(TeamAObjectIds) do
		if CheckUnitAlive(v) then
			ShowcaseUnitAndTheirAura(v)
		end
	end
	FocusCamera({ Fraction = preAuraSequenceZoom, ZoomType = "Ease", Duration = 1 })
	wait(1)
end

function ShowcaseUnitAndTheirAura( unitId )
	local randomCameraDuration = RandomFloat(1.1, 1.4)
	local randomCameraZoom = preAuraSequenceZoom * RandomFloat (0.88, 0.99)
	PanCamera({ Id = unitId, Duration = randomCameraDuration, EaseIn = 0.05, EaseOut = 0.2 })
	FocusCamera({ Fraction = randomCameraZoom, ZoomType = "Overshoot", Duration = randomCameraDuration/2, Delay = 0.3 })

	local unitName = GetName({ Id = unitId })
	if unitName == "PlayerLarge" then
		thread( SpecialDemonTaunt, unitId, "overrideTaunt" )
	end
	if ArchetypeData[unitName].SpecialAuraTurnOn then
		PlayAnimation({ Name = ArchetypeData[unitName].SpecialAuraTurnOn, DestinationId = unitId })
	else
		PlayAnimation({ Name = ArchetypeData[unitName].AuraOnAnimation, DestinationId = unitId })
	end

	local unitData = GetCharacterTableByObjectId( unitId )
	if unitName == "PlayerMedium" then
		thread( EmoteEvade, unitData["VoicePrefix"], unitId )
	end

	wait(0.45)

	local equippedAura = GetUnitDataStringValue({ Id = unitId, Property = "ContinuousWeapon" })
	SetWeaponProperty({ DestinationId = unitId, WeaponName = equippedAura, PropertyName = "Enabled", Value = true  })
	PlaySound({ Name = "/SFX/Match SFX/AuraOnLoud", Id = unitId })
	wait(randomCameraDuration * 0.8)
end

OnTriggerFired{ "EnemyAlive",
	function(triggerArgs)

		SetConfigOption({ Name = "PlayerTwoAI", Value = false })

		local currentTutorialZoom = GetCameraZoom({ })
		local currentActiveUnit = GetActiveUnitId({ PlayerIndex = 1 })
		PanCamera({ Ids = {currentActiveUnit, 20108}, Duration = 2, EaseIn = 0.2, EaseOut = 1 })

		--ToggleControl({ Names = { "Pass", "CycleRight", "CycleLeft"}, Enabled = false })
		ToggleControl({ Names = { "Pass" }, Enabled = false })

		SetObstacleProperty({ Id = ballId, Name = "HaltedByFluid", Value = false }) -- so the ball will actually bounce
		fakeFumble = true

		fakeDeathTimer = true

		DisplayObjective("CatchEnemyInAuraTutorial")
		PlayOverheadAnimation({ Name = "ArrowIndicator3", DestinationId = 20108 })

		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)

		rivalImpassA = SpawnObstacle({ Name = "_Impassable_OvalUnitsOnly", DestinationId = 190006, OffsetY = 30 })
		rivalImpassB = SpawnObstacle({ Name = "_Impassable_OvalProjectilesAndUnitsAllowFluid", DestinationId = 190005 })
		SetScale({ Id = rivalImpassA, Fraction = 1.3 })
		SetScale({ Id = rivalImpassB, Fraction = 0.7 })
		SetInvulnerable({ Id = 190006 })
		SetInvulnerable({ Id = 190005 })
	end
}

OnDestroyAny{ "TeamB",
	RequiredFlag = "CatchEnemyInAuraTutorial",
	function( triggerArgs )
		local introKiller = triggerArgs.KillerId
		local introVictim = triggerArgs.triggeredById

		if introVictim == 20108 then
			AddInputBlock({ Name = "CatchEnemyInAuraTutorial" })

			Halt({ Id = introKiller })
			Stop({ Id = introKiller })

			Delete({ Ids = {rivalImpassA, rivalImpassB } })
			SetVulnerable({ Ids = {190005, 190006} })

			local victimLocation = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = 20108, Group = "Scripting" })
			local currentVictimZoom = GetCameraZoom({ })
			PanCamera({ Id = victimLocation, EaseIn = 0.05, EaseOut = 0.2, Duration = 1.1 })
			FocusCamera({ Fraction = currentVictimZoom * 1.15, Duration = 6.1, ZoomType = "Ease" })

			MarkObjectiveComplete("CatchEnemyInAuraTutorial")

			wait(0.25)
			DisplayInfoPanelText({ Name = "Info_AuraBanishment", Duration = 3.0 })

			thread(ShowInputDisabledPresentation)
			thread( PlayIntroMatchSpeech, "rivaltagged" )

			thread(CheckIfPlayerTooCloseToBall)

			-- delay to space this out a bit
			wait(3.45)

			PanCamera({ Id = 190006, Duration = 3, EaseIn = 1, EaseOut = 0.5 })

			SetFlagFalse({ Name = "CatchEnemyInAuraTutorial" })
			StopAnimation({ Name = "ArrowIndicator3", DestinationId = 20108, Delay = 0, Duration = 0.25 })
			wait(0.05)

			--ApplyUpwardForce({ Id = ballId, Speed = -900 })
			--ApplyForce({ Id = ballId, Speed = 900, Angle = 45 })

			--MarkObjectiveComplete("CatchEnemyInAuraTutorial")
			fakeFumble = false

			SetInvulnerable({ Id = 190006 })
			RivalGetBall()
			SetVulnerable({ Id = 190006 })

			rivalImpass01 = SpawnObstacle({ Name = "_Impassable_OvalUnitsOnly", DestinationId = 190006, OffsetY = 30 })
			rivalImpass02 = SpawnObstacle({ Name = "_Impassable_OvalProjectilesAndUnitsAllowFluid", DestinationId = 190005 })
			SetScale({ Id = rivalImpass01, Fraction = 1.3 })
			SetScale({ Id = rivalImpass02, Fraction = 0.7 })
			SetInvulnerable({ Id = 190005 })
		end
	end
}

function CheckIfPlayerTooCloseToBall()
	local currentPlayerControlledUnit = GetActiveUnitId({ PlayerIndex = 1 })
	wait(1)
	if GetDistance({ Id = currentPlayerControlledUnit, DestinationId = ballId }) <= 450 then
		SetInvulnerable({ Id = currentPlayerControlledUnit })
		Move({ Id = currentPlayerControlledUnit, DestinationId = 50029 })
	end
	wait(3)
	AngleTowardTarget({ Id = currentPlayerControlledUnit, DestinationId = 190006 })
	SetVulnerable({ Id = currentPlayerControlledUnit })
end

function CheckIfPlayerTooCloseToPosition( position, checkDelay )
	local currentPlayerControlledUnit = GetActiveUnitId({ PlayerIndex = 1 })
	DisableInput({ PlayerIndex = 1 })
	SetInvulnerable({ Id = currentPlayerControlledUnit })
	adjustingPlayerPosition = true
	if GetDistance({ Id = currentPlayerControlledUnit, DestinationId = position }) <= 450 then
		if checkDelay ~= nil and checkDelay > 0 then
			Move({ Id = currentPlayerControlledUnit, DestinationId = 50032, Delay = checkDelay })
		else
			Move({ Id = currentPlayerControlledUnit, DestinationId = 50032, Delay = 0 })
		end
		wait(3)
		AngleTowardTarget({ Id = currentPlayerControlledUnit, DestinationId = goalB })
	end
	adjustingPlayerPosition = false
	SetVulnerable({ Id = currentPlayerControlledUnit })
end

function EnemyRespawnSequence()
	SetFlagTrue({ Name = "EnemyReviveSequence" })
	PanCamera({ Id = goalB, OffsetY = -200, OffsetX = -250, Duration = 3.5, EaseIn = 0.1, EaseOut = 0.5 })
	wait(3.2)
	for k, v in pairs(TeamBObjectIds) do
		local playerTable = GetCharacterTableByObjectId(v)
		if playerTable["RespawnTimer"] > 1 then
			RespawnUnit(playerTable.ObjectId)
			wait(0.6)
		end
	end

	wait(0.4)
	fakeDeathTimer = false
	DisplayInfoPanelText({ Name = "Info_Respawning", Duration = 3.0 })
	wait(3.5)
end

function RivalGetBall()
	wait(2.5)
	SwitchActiveUnit({ Id = 190006, PlayerIndex = 2 })
	Move({ Id = 190006, DestinationId = ballId, Mode = "Precise" })

	SetFlagTrue({ Name = "RivalRecoversBall" })
	while true do
		if GetDistance({ Id = 190006, DestinationId = ballId }) < 80 then
			EnableInput({ PlayerIndex = 2 })
			break
		else
			DisableInput({ PlayerIndex = 2 })
			Move({ Id = 190006, DestinationId = ballId, Mode = "Precise" })
			wait(0.1)
		end
	end
end

function ShowControlsUITutorial()
	--wait(2.5)
	if not GetConfigOptionValue({ Name = "ShowControlsHUD" }) then
		DebugPrint({  Text = "A" })
		return
	end
	if slowCam then
		DebugPrint({  Text = "C" })
	end
	if controlsHint then
		--return
	end
	controlsHint = true

	DisplayTutorialBox({ HelpTextId = "Info_ControlsUI", X = 960, Y = 680, Animation = "TutorialBoxSmallIn", Arrow = "Down" })
	wait(4.5)
	HideTutorialBox()
end

OnKeyPressed{ "Alt O",
	function(triggerArgs)
		ShowControlsUITutorial()
	end
}

OnUsed{ "Token",
	RequiredFlag = "RivalRecoversBall",
	function(triggerArgs)
		SetFlagFalse({ Name = "RivalRecoversBall" })

		DisableInput({ PlayerIndex = 2 })

		if not fancyCamera then
			local currentTutorialZoom = GetCameraZoom({ })
			local currentActiveUnit = GetActiveUnitId({ PlayerIndex = 1 })
			PanCamera({ Ids = { currentActiveUnit, 190006 }, Duration = 2, EaseIn = 0.2, EaseOut = 1, Retarget = true })
			FocusCamera({ Fraction = currentTutorialZoom * 1.05, Duration = 2, ZoomType = "Overshoot" })
		end

		wait(1)

		ToggleControl({ Names = { "Cast" }, Enabled = true })
		ToggleControl({ Names = { "AutoLock" }, Enabled = true })

		thread( PlayIntroMatchSpeech, "aurathrow" )

		fakeFumble2 = true

		PlayOverheadAnimation({ Name = "ArrowIndicator3", DestinationId = 190006 })

		DisplayObjective("CastTutorial")
		EnableInput({ PlayerIndex = 1 })
		RemoveInputBlock({ Name = "CatchEnemyInAuraTutorial" })
		thread(HideInputDisabledPresentation)
		--ToggleControl({ Names = { "Move" }, Enabled = false })
		wait(2)
	end
}

function MidAirCatch()
	SwitchActiveUnit({ Id = 190005, PlayerIndex = 2 })
	Move({ Id = 190005, DestinationId = ballId, Mode = "Precise" })

	while true do
		if GetDistance({ Id = 190005, DestinationId = ballId }) < 80 then
			EnableInput({ PlayerIndex = 2 })
			break
		else
			DisableInput({ PlayerIndex = 2 })
			Move({ Id = 190005, DestinationId = ballId, Mode = "Precise" })
			wait(0.1)
		end
	end
end

OnDestroyAny{ "TeamB",
	RequiredFlag = "CastTutorial",
	function(triggerArgs)

		if triggerArgs.name == nil or not string.match( triggerArgs.name, "Cast" ) then
			return
		end

		Halt({ Id = triggerArgs.KillerId })
		Stop({ Id = triggerArgs.KillerId })

		StopAnimation({ Name = "ArrowIndicator3", DestinationId = 190006, Delay = 0, Duration = 0.25 })

		SetFlagFalse({ Name = "CastTutorial" })
		blockCastReleaseHint = true

		DisableInput({ PlayerIndex = 1 })
		thread(ShowInputDisabledPresentation)

		Delete({ Ids = {rivalImpass01, rivalImpass02} })

		local caster = triggerArgs.KillerId
		local victimLocation = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = triggerArgs.triggeredById, Group = "Scripting" })
		PanCamera({ Ids = { caster, victimLocation }, Duration = 0.6, EaseIn = 0.05, EaseOut = 0.1 })

		wait(0.65)
		thread( PlayIntroMatchSpeech, "rivalshot" )
		MarkObjectiveComplete( "CastTutorial" )
		CheckIfPlayerTooCloseToPosition( 40009 )
		wait(0.7)
		MidAirCatch()
		wait(0.5)
		fakeFumble2 = false

		thread( PlayIntroMatchSpeech, "banishremainingrival" )
		PlayOverheadAnimation({ Name = "ArrowIndicator3", DestinationId = 190005 })
		DisplayObjective("CastOrCatchEnemyTutorial")
		SetVulnerable({ Id = 190005 })
		DisableInput({ PlayerIndex = 2 })
		wait(0.3)
		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)
		UseableOff({ Id = ballId })
	end
}

OnDestroyAny{"TeamB",
	RequiredFlag="CastOrCatchEnemyTutorial",
	function(triggerArgs)

		fakeFumble3 = true
		DisableInput({ PlayerIndex = 1 })
		thread(ShowInputDisabledPresentation)

		Halt({ Id = triggerArgs.KillerId })
		Stop({ Id = triggerArgs.KillerId })

		StopAnimation({ Name = "ArrowIndicator3", DestinationId = 190005, Delay = 0, Duration = 0.25 })

		local caster = triggerArgs.KillerId
		local victimLocation = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = triggerArgs.triggeredById, Group = "Scripting" })
		PanCamera({ Ids = { caster, victimLocation }, Duration = 0.6, EaseIn = 0.05, EaseOut = 0.1 })

		thread( PlayIntroMatchSpeech, "banishremainingrivalcomplete" )
		MarkObjectiveComplete("CastOrCatchEnemyTutorial")

		wait(0.4)

		thread(CheckIfPlayerTooCloseToPosition, StartingPositions[190005], 0.8)
		thread(CheckIfPlayerTooCloseToPosition, StartingPositions[20108], 0.8)
		thread(CheckIfPlayerTooCloseToPosition, StartingPositions[190005], 0.8)

		if adjustingPlayerPosition then
			wait(1.6)
		end
		FireTrigger({ Name = "SetupReclaimOrbTutorial" })
	end
}

OnTriggerFired{ "SetupReclaimOrbTutorial",
	function(triggerArgs)

		--wait(0.5)
		--EnemyRespawnSequence()
		--wait(0.3)
		EnemyRespawnSequence()
		wait(0.5)

		fakeFumble3 = false

		wait(0.2)

		PanCamera({ Ids = { 40002, ballId }, Duration = 1.5, EaseIn = 0.1, EaseOut = 0.3 })
		--PlayOverheadAnimation({ Name = "ArrowIndicator3", DestinationId = ballId })

		ToggleControl({ Names = {"AutoLock", "Cast" }, Enabled = false })

		thread( PlayIntroMatchSpeech, "reclaimorb" )
		DisplayObjective("GetBallFromRivalsTutorial")

		--SetObstacleProperty({ Id = ballId, Name = "HaltedByFluid", Value = true })

		-- make enemies invulnerable
		rivalImpassC = SpawnObstacle({ Name = "_Impassable_OvalProjectilesAndUnitsAllowFluid", DestinationId = 190006, OffsetY = 30 })
		rivalImpassD = SpawnObstacle({ Name = "_Impassable_OvalProjectilesAndUnitsAllowFluid", DestinationId = 20108 })
		rivalImpassE = SpawnObstacle({ Name = "_Impassable_OvalProjectilesAndUnitsAllowFluid", DestinationId = 190005 })
		SetScale({ Id = rivalImpassC, Fraction = 1.1 })
		SetScale({ Id = rivalImpassD, Fraction = 0.9 })
		SetScale({ Id = rivalImpassE, Fraction = 0.6 })
		SetInvulnerable({ Id = 190006 })
		SetInvulnerable({ Id = 20108 })
		SetInvulnerable({ Id = 190005 })

		wait(0.3)

		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)
		UseableOn({ Id = ballId, Delay = 0.8 })

		disableMatchCamera = false
		blockFancyCamera = false
		fancyCamera = true
		thread(MatchCameraSelector)
	end
}

OnControlPressed{ "Cast",
	RequiredFlag = "CastTutorial",
	function(triggerArgs)
		wait(0.4)
		castReleaseCheck = true

		wait(2.6)
		if not blockCastReleaseHint then
			DisplayInfoPanelText({ Name = "Info_ReleaseToFire", Duration = 2 })
			thread( PlayIntroMatchSpeech, "firewhenready" )
		end
	end
}

OnControlReleased{ "Cast",
	RequiredFlag = "CastTutorial",
	function(triggerArgs)
		if castReleaseCheck then
			blockCastReleaseHint = true
		end
	end
}

OnUsed{ "Token",
	RequiredFlag = "GetBallFromRivalsTutorial",
	function(triggerArgs)
		DisableInput({ PlayerIndex = 1 })
		thread(ShowInputDisabledPresentation)

		SetFlagFalse({ Name = "GetBallFromRivalsTutorial" })
		-- thread( PlayIntroMatchSpeech, "reclaimorb" )

		thread( PlayIntroMatchSpeech, "recoveredtheball" )
		MarkObjectiveComplete("GetBallFromRivalsTutorial")

		-- clear impass/invuln
		Delete({ Ids = {rivalImpassC, rivalImpassD, rivalImpassE} })
		SetVulnerable({  Ids = { 190006, 20108, 190005 } })

		local currentlyActiveTutorialUnit = GetActiveUnitId({ PlayerIndex = 1 })
		--SetInvulnerable({ Id = currentlyActiveTutorialUnit })

		thread(PutEnemiesBackInPlace)

		-- switch from Jodi if she's the active unit
		if GetName({ Id = currentlyActiveTutorialUnit }) == "PlayerLarge" then
			DebugPrint({ Text = "Switch off of Jodi for Jump Tutorial!" })
			thread(PutJodiBackInPlace)
			if currentlyActiveTutorialUnit == 190001 then
				if lastScorer == 20001 then
					SwitchActiveUnit({ Id = 190000, PlayerIndex = 1 })
				else
					SwitchActiveUnit({ Id = 20001, PlayerIndex = 1 })
				end
			end
		end

		wait(0.3)
		DisplayInfoPanelText({ Name = "Info_AurasOff", Duration = 3 })

		wait(1.8)

		currentlyActiveTutorialUnit = GetActiveUnitId({ PlayerIndex = 1 })
		Move({ Id = currentlyActiveTutorialUnit, DestinationId = 40011, Delay = 2.5 })

		wait(4)

		ToggleControl({ Names = { "Jump" }, Enabled = true })
		ToggleControl({ Names = { "Pass", "Cast", "AutoLock" }, Enabled = false })
		--DisplayObjective("JumpTutorial")


		wait(0.65)
		jumpGoal = true

		AngleTowardTarget({ Id = currentlyActiveTutorialUnit, DestinationId = goalB })

		PanCamera({ Ids = { currentlyActiveTutorialUnit,  goalB }, EaseIn = 0.05, EaseOut = 0.2, Duration = 3 })
		wait(1)

		thread( PlayIntroMatchSpeech, "jumpintopyre" )

		thread(FakeJumpPresentation, currentlyActiveTutorialUnit)
		DisplayObjective("JumpTutorialGoal")
		DisableInput({ PlayerIndex = 2 })

		for k, character in pairs( TeamB.AssignedCharacters ) do
			-- Enemies cannot be impacted here
			SetThingProperty({ Name = "Grip", Value = 999999, DestinationId = character.ObjectId })
		end

		wait(0.3)

		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)

	end
}

function MakeJumpTutorialGoalEasier()
	--DisplayInfoPanelText({ Name = "MakingEasier" })
	DisableInput({ PlayerIndex = 2 })
	Move({ Id = 190005, DestinationId = 50031, OffsetX = 0 })
	wait(0.6)
	AngleTowardTarget({ Id = 190005, DestinationId = goalA })
end

function PutJodiBackInPlace()
	SendUnitToTarget( 190001, 50003, goalB, nil  )
end

function FakeJumpPresentation( startingUnit )
	fakeJumpPresentation = true
	while fakeJumpPresentation do

		local startingUnitData = GetCharacterTableByObjectId( startingUnit )
		local startingUnitWalkAnimation = startingUnitData.Archetype.."Walk"
		local startingUnitWalkJump = startingUnitData.Archetype.."Evade"

		if startingUnitData.Archetype == "PlayerLarge" then
			startingUnitWalkJump = "PlayerLargeEvadeFire"
		end

		local fakeJumper = SpawnObstacle({ Name = "BlankObstacle", DestinationId = 40011, Group = "Art_Standing01" })
		SetColor({ Id = fakeJumper, Color = Color.Black })
		PlayAnimation({ Name = startingUnitWalkAnimation, DestinationId = fakeJumper })

		local fakeJumpDestination = 40009
		Move({ Id = fakeJumper, DestinationId = fakeJumpDestination, Speed = 300 })

		wait(1)
		Move({ Id = fakeJumper, DestinationId = fakeJumpDestination, OffsetX = 250, Duration = 0.4 })
		PlayAnimation({ Name = startingUnitWalkJump, DestinationId = fakeJumper })
		wait(0.2)
		SetOpacity({ Id = fakeJumper, Fraction = 0, Duration = 0.2 })
		wait(0.2)
		Delete({ Id = fakeJumper })

		wait(4.6)
		if not fakeJumpPresentation then
			break
		end
	end
end

function ShowSacrificedUnitRespawn()
	if shownUnitReturn then
		return
	end
	showUnitReturn = true

	midMatchEventLive = true
	DisableInput({ PlayerIndex = 1 })
	thread(ShowInputDisabledPresentation)
	blockFancyCamera = true
	PanCamera({ Id = FirstSacrificedUnit.ObjectId, Duration = 1, EaseIn = 0.05, EaseOut = 0.2 })
	FocusCamera({ Fraction = 0.6, Duration = 5, ZoomType = "Ease" })

	wait(1)
	DisplayInfoPanelText({ Name = "Info_SacrificedUnitReturns", Duration = 3 })
	SwitchActiveUnit({ Id = FirstSacrificedUnit.ObjectId, PlayerIndex = 1 })

	wait(3)
	thread( PlayIntroMatchSpeech, "winthematch" )

	wait(1)

	CommenceIntroMatchFreePlay()
end

function CommenceIntroMatchFreePlay()

	SetFlagTrue({ Name = "AllowWinMatch" })

	SetConfigOption({ Name = "PlayerAIEvaluateBall", Value = true })
	SetConfigOption({ Name = "PlayerAIEvaluateGoal", Value = true })
	SetConfigOption({ Name = "PlayerAIEvaluatePass", Value = true })
	SetConfigOption({ Name = "PlayerAIEvaluateThrow", Value = false })
	SetConfigOption({ Name = "PlayerAIEvaluateWeapon", Value = false })
	SetConfigOption({ Name = "PlayerAIEvaluateEvade", Value = false })
	SetConfigOption({ Name = "PlayerAIEvaluateSprint", Value = false })
	SetConfigOption({ Name = "PlayerAIEvaluateNeutralThrow", Value = false })
	SetConfigOption({ Name = "PlayerAIExecuteScore", Value = true })
	SetConfigOption({ Name = "PlayerTwoAIHandicap", Value = 5 })

	--SetConfigOption({ Name = "PlayerTwoAI", Value = true })

	--wait(3.5)

	DisplayObjective("WinMatchTutorial")

	blockMatchVO = false

	SetTimer({ Name = "IntroMatchFreePlay",  Id = 0 })
	StartTimer({ Name = "IntroMatchFreePlay" })
	--DisplayObjective("WinMatchGeneral")

	EnableInput({ PlayerIndex = 1 })
	thread(HideInputDisabledPresentation)

	disableMatchCamera = false
	blockFancyCamera = false
	fancyCamera = true
	thread(MatchCameraSelector)

	SetFlagTrue({ Name = "TallyPlayerActions" })
	SetFlagTrue({ Name = "CheckForAITurnOn" })
	midMatchEventLive = false
	freeMatch = true

	--SetConfigOption({ Name = "PlayerTwoAI", Value = true, Delay = 12 })
	--ShowControlsUITutorial()
end

OnUsed{ "Token",
	RequiredFlag = "CheckForAITurnOn",
	function(triggerArgs)
		SetFlagFalse({ Name = "CheckForAITurnOn" })
		SetConfigOption({ Name = "PlayerTwoAI", Value = true })
		EnableInput({ PlayerIndex = 2 })
	end
}

OnPlayerDistanceAny{"GoalB < 950",
	RequiredFlag = "CheckForAITurnOn",
	function(triggerArgs)
		SetFlagFalse({ Name = "CheckForAITurnOn" })
		SetConfigOption({ Name = "PlayerTwoAI", Value = true })
		EnableInput({ PlayerIndex = 2 })
	end
}

OnDestroyAny{"TeamB",
	RequiredFlag = "CheckForAITurnOn",
	function(triggerArgs)
		SetFlagFalse({ Name = "CheckForAITurnOn" })
		SetConfigOption({ Name = "PlayerTwoAI", Value = true })
		EnableInput({ PlayerIndex = 2 })
	end
}

function MatchObjectiveHint()
	if not firstMatch or matchObjective then
		return
	end

	waitUntil("firstMatchScoreSequenceComplete")
	wait(0.45)
	--DisplayInfoPanelText({ Name = "Info_MatchObjective", Duration = 3.5 })
	--[[
	DisplayObjective("WinMatch")
	wait(0.5)
	DisplayInfoPanelText({ Name = "Info_Score_Values", Duration = 3.5 })
	wait(4.15)
	]]
	notifyExistingWaiters("firstMatchScoreHintsComplete")
	matchObjective = true
end

OnActiveUnitChanged
{
	RequiredFlag = "WeekOneMatchTutorial",
	function(triggerArgs)

		local activeUnit = GetActiveUnitId({  PlayerIndex = 1 })
		if activeUnit == BallCarrierId and not throwHint then
			throwHint = true
			DisplayObjective("ThrowTutorial")
			return
		end

	end
}

OnDestroyAny{
"TeamA",
	RequiredFlag = "FirstMatchTutorial",
	function(triggerArgs)

		-- commented out for now because it happens on sacrifice scoring
		if true then
			return
		end

		if not firstMatch then
			return
		end

		if not auraDangerHint then
			auraDangerHint = true
			wait(0.3)
			DisplayInfoPanelText({ Name = "Info_AuraDanger", Duration = 2.25 })
			SetFlagTrue({ Name = "AllowEvadeHint", Delay = 6 })
		end
	end
}


OnDestroyAny{
	"TeamA",
	RequiredFlag = "AllowEvadeHint",
	function(triggerArgs)
		if not auraEvadeHint then
			auraEvadeHint = true
			SetFlagFalse({ Name = "AllowEvadeHint" })
			--thread(CombatInfoPanelCam, 3)
			--ShowHint("Info_Evade")
		end
	end
}

-- MATCHSITE B

function IndicateThrowScorePosition()
	tossTutorial = true
end

-- MATCH OBJECTIVES

MatchObjectives =
{
	-- Intro Match Objectives
	["PassTutorial"] =
	{
		TitleText = "Objective_PassTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "PassTutorial",
	},

	["PassHoldTutorial"] =
	{
		TitleText = "Objective_PassHoldTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "PassHoldTutorial",
	},


	["SprintTutorial"] =
	{
		TitleText = "Objective_SprintTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "SprintTutorial",
	},

	["StaminaTutorial"] =
	{
		TitleText = "Objective_StaminaTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "StaminaTutorial",
	},

	["JumpTutorial"] =
	{
		TitleText = "Objective_JumpTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "JumpTutorial",
	},

	["JumpTutorialGoal"] =
	{
		TitleText = "Objective_JumpTutorialGoal",
		NumCompletions = 0,
		GlobalRequiredFlag = "JumpTutorialGoal",
	},

	["CastTutorial"] =
	{
		TitleText = "Objective_CastTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "CastTutorial",
	},

	["CastOrCatchEnemyTutorial"] =
	{
		TitleText = "Objective_CastOrCatchEnemyTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "CastOrCatchEnemyTutorial",
	},

	["GoalsTutorial"] =
	{
		TitleText = "Objective_GoalsTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "GoalsTutorial",
	},

	["GetBallTutorial"] =
	{
		TitleText = "Objective_GetBallTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "GetBallTutorial",
	},

	["CatchEnemyInAuraTutorial"] =
	{
		TitleText = "Objective_CatchEnemyInAuraTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "CatchEnemyInAuraTutorial",
	},

	["GetBallFromRivalsTutorial"] =
	{
		TitleText = "Objective_GetBallFromRivalsTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "GetBallFromRivalsTutorial",
	},

	["WinMatchTutorial"] =
	{
		TitleText = "Objective_WinMatchTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "WinMatchTutorial",
	},
	["WinMatchSuddenDeath"] =
	{
		TitleText = "Objective_WinMatchSuddenDeath",
		NumCompletions = 0,
		GlobalRequiredFlag = "WinMatchSuddenDeath",
	},

	["SprintTutorial2"] =
	{
		TitleText = "Objective_SprintTutorial2",
		NumCompletions = 0,
		GlobalRequiredFlag = "SprintTutorial2",
		ShowProgress = true,
		CurrentCount = 0,
		MaxCount = 3,
	},

	["JumpTutorial2"] =
	{
		TitleText = "Objective_JumpTutorial2",
		NumCompletions = 0,
		GlobalRequiredFlag = "JumpTutorial2",
		ShowProgress = true,
		CurrentCount = 0,
		MaxCount = 3,
	},

	["CastTutorial2"] =
	{
		TitleText = "Objective_CastTutorial2",
		NumCompletions = 0,
		GlobalRequiredFlag = "CastTutorial2",
		ShowProgress = true,
		CurrentCount = 0,
		MaxCount = 3,
	},

	["WinMatch"] =
	{
		TitleText = "Objective_WinMatch",
		NumCompletions = 0,
		GlobalRequiredFlag = "WinMatch",
	},

	-- First Match Objectives
	["WinMatchGeneral"] =
	{
		TitleText = "Objective_WinMatchGeneral",
		GlobalRequiredFlag = "WinMatchGeneral",
	},

	["ThrowTutorial"] =
	{
		TitleText = "Objective_ThrowTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "ThrowTutorial",
	},

	["ThrowScore"] =
	{
		TitleText = "Objective_ThrowScore",
		NumCompletions = 0,
		GlobalRequiredFlag = "ThrowScore",
	},

	["GetPowerUps"] =
	{
		TitleText = "Objective_GetPowerUps",
		GlobalRequiredFlag = "GetPowerUps",
		ShowProgress = true,
		CurrentCount = 0,
		MaxCount = 3,
	},

	["BreakAuraLink"] =
	{
		TitleText = "Objective_BreakAuraLink",
		NumCompletions = 0,
		GlobalRequiredFlag = "BreakAuraLink",
	},

	["HandleAuraRage"] =
	{
		TitleText = "Objective_HandleAuraRage",
		NumCompletions = 0,
		GlobalRequiredFlag = "HandleAuraRage",
	},

	["EmbracePoison"] =
	{
		TitleText = "Objective_EmbracePoison",
		NumCompletions = 0,
		GlobalRequiredFlag = "EmbracePoison",
		ShowProgress = true,
		CurrentCount = 0,
		MaxCount = 6,
	},

	["DefeatingCrones01"] =
	{
		ShowProgress = true,
		MaxCount = 30,
	},

	["DefeatingTrails01"] =
	{
		ShowProgress = true,
		MaxCount = 5,
	},

	["DefeatingFlying01"] =
	{
		ShowProgress = true,
		MaxCount = 3,

	},

	["DefeatingTrees01"] =
	{
		TitleText = "DefeatingTrees01",
		MaxCount=1,
		GlobalRequiredFlag = "DefeatingTrees",
	},

	["ImpJump"] =
	{
		TitleText = "Objective_ImpJumpTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "ImpJumpTutorial",
	},

	["ImpSprint"] =
	{
		TitleText = "Objective_ImpSprintTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "ImpSprintTutorial",
		ShowProgress = true,
		MaxCount = 7,
	},

	["ImpCast"] =
	{
		TitleText = "Objective_ImpCastTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "ImpCastTutorial",
	},

	["ImpTaunt"] =
	{
		TitleText = "Objective_ImpTauntTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "ImpTauntTutorial",
	},

	["FlyingSprint"] =
	{
		TitleText = "Objective_FlyingSprintTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "FlyingSprintTutorial",
		ShowProgress = true,
		MaxCount = 4,
	},

	["FlyingJump"] =
	{
		TitleText = "Objective_FlyingJumpTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "FlyingJumpTutorial",
	},

	["FlyingWeapon"] =
	{
		TitleText = "Objective_FlyingWeaponTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "FlyingWeaponTutorial",
		ShowProgress = true,
		MaxCount = 3,
	},

	["FlyingMixUse"] =
	{
		TitleText = "Objective_FlyingMixUseTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "FlyingMixUseTutorial",
	},

	["MonsterJump"] =
	{
		TitleText = "Objective_MonsterJumpTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "MonsterJumpTutorial",
		ShowProgress = true,
		MaxCount = 3,
	},

	["MonsterSprint"] =
	{
		TitleText = "Objective_MonsterSprintTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "MonsterSprintTutorial",
	},

	["MonsterCast"] =
	{
		TitleText = "Objective_MonsterCastTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "MonsterCastTutorial",
		ShowProgress = true,
		MaxCount = 3,
	},

	["MonsterPowerCast"] =
	{
		TitleText = "Objective_MonsterPowerCastTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "MonsterPowerCastTutorial",
	},

	["MonsterTaunt"] =
	{
		TitleText = "Objective_MonsterTauntTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "MonsterTauntTutorial",
	},


	["TreeJump"] =
	{
		TitleText = "Objective_TreeJumpTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "TreeJumpTutorial",
		ShowProgress = true,
		MaxCount = 3,
	},

	["TreeSprint"] =
	{
		TitleText = "Objective_TreeSprintTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "TreeSprintTutorial",
		ShowProgress = true,
		MaxCount = 4,
	},

	["TreeCast"] =
	{
		TitleText = "Objective_TreeCastTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "TreeCastTutorial",
		ShowProgress = true,
		MaxCount = 3,
	},

	["TreeTaunt"] =
	{
		TitleText = "Objective_TreeTauntTutorial",
		NumCompletions = 0,
		GlobalRequiredFlag = "TreeTauntTutorial",
	},

	["WinShowdown"] =
	{
		TitleText = "Objective_WinShowdown",
		NumCompletions = 0,
		GlobalRequiredFlag = "WinShowdown",
	},

	["AscensionScore"] =
	{
		TitleText = "Objective_AscensionScore",
		NumCompletions = 0,
		GlobalRequiredFlag = "AscensionScore",
	},

	["StartFreeplayMatch"] =
	{
		TitleText = "Objective_StartFreePlay",
		NumCompletions = 0,
		GlobalRequiredFlag = "StartFreePlay",
	},

	-- Additional Objectives
	["ThrowScoreTwice"] =
	{
		TitleText = "Objective_ThrowScoreTwice",
		GlobalRequiredFlag = "ThrowScoreTwiceObjective",
		MinMatchRequirement = 0,
	},

	["JumpScore"] =
	{
		TitleText = "Objective_JumpScore",
		GlobalRequiredFlag = "JumpScore",
		MinMatchRequirement = 0,
	},

	["SprintScore"] =
	{
		TitleText = "Objective_SprintScore",
		GlobalRequiredFlag = "SprintScore",
		MinMatchRequirement = 0,
		Type = "MatchStartChallenge",
	},

	-- Practice Match Objectives
	["FinishPracticeMatch"] =
	{
	},

	-- Special Map Objectives
	["WinMatchBrawl"] =
	{
		TitleText = "Objective_WinMatchBrawl",
		GlobalRequiredFlag = "WinMatchBrawl",
	},

	["DefendCaravan"] =
	{
		TitleText = "Objective_DefendCaravan",
		GlobalRequiredFlag = "DefendCaravan",
	},

	["PowerShotTutorial"] =
	{
		TitleText = "Objective_DefensePowershotTutorial",
		GlobalRequiredFlag = "DefendCaravan",
	},

	["PowerShotTutorial2"] =
	{
		TitleText = "Objective_DefensePowershotTutorial2",
		GlobalRequiredFlag = "DefendCaravan",
		MaxCount = 5,
		ShowProgress= true,
		NextObjectiveUp="JumpPowerShotTutorial",
		NextObjectiveUpWait = 1.2,
	},

	["JumpPowerShotTutorial"] =
	{
		TitleText = "Objective_DefenseJumpPowerShotTutorial",
		GlobalRequiredFlag = "DefendCaravan",
		MaxCount = 3,
		ShowProgress= true,
	},


	["EliminateInvaders"] =
	{
		TitleText = "Objective_EliminateInvaders",
		GlobalRequiredFlag = "EliminateInvaders",
		ShowGoldBalance = true,
		MaxCount = 100,
		CurrentCount = 0
	},

	["RetrievalFindObject"] =
	{
		TitleText = "Objective_RetrievalFindObject",
		GlobalRequiredFlag = "RetrievalFindObject",
	},

	["RetrievalBurrow"] =
	{
		TitleText = "Objective_RetrievalBurrow",
		GlobalRequiredFlag = "RetrievalBurrow",
	},

	["RetrievalDestroy"] =
	{
		TitleText = "Objective_RetrievalDestroy",
		GlobalRequiredFlag = "RetrievalDestroy",
	},

	["RetrievalDispatch"] =
	{
		TitleText = "Objective_RetrievalDispatch",
		GlobalRequiredFlag = "RetrievalDispatch",
		ShowProgress = true,
		MaxCount = 8,
	},

	["RetrievalTake"] =
	{
		TitleText = "Objective_RetrievalTake",
		GlobalRequiredFlag = "RetrievalTake",
	},

	["RetrievalTakeBack"] =
	{
		TitleText = "Objective_RetrievalTakeBack",
		GlobalRequiredFlag = "RetrievalTakeBack",
	},

	["RetrievalEscape"] =
	{
		TitleText = "Objective_RetrievalEscape",
		GlobalRequiredFlag = "RetrievalEscape",
	},

	-- Quest Prototype Objectives
	["QuestPrototype01"] =
	{
		TitleText = "Objective_StarMap_Intro",
		GlobalRequiredFlag = "QuestPrototype01",
		Campaign = true,
	},
	["QuestPrototype02"] =
	{
		TitleText = "Objective_QuestPrototype02",
		GlobalRequiredFlag = "QuestPrototype02",
		Campaign = true,
	},
	["QuestPrototype03"] =
	{
		TitleText = "Objective_QuestPrototype03",
		GlobalRequiredFlag = "QuestPrototype03",
		Campaign = true,
	},

	-- Star Picker Objective
	["QuestNextMatch01"] =
	{
		TitleText = "Objective_QuestNextMatch01",
		GlobalRequiredFlag = "QuestNextMatch01",
		MapObjectType = "NextMatch",
		Campaign = true,
		CampaignPriority = 1,
	},

	-- Overmap Objectives
	["QuestFindMinstrel"] =
	{
		TitleText = "Objective_QuestFindMinstrel",
		GlobalRequiredFlag = "QuestFindMinstrel",
		MapObjectType = "UnknownLocation",
		MapObjectLocationIds = { 10007, 10008, 10009 },
		Campaign = true,
		CampaignPriority = 2,
	},
	["QuestAmassGold"] =
	{
		TitleText = "Objective_QuestGold01",
		GlobalRequiredFlag = "QuestAmassGold",
		MapObjectType = "Shop",
		Campaign = true,
		CampaignPriority = 3,
		MaxCount = 1000,
		ShowProgress = true,
	},

	["QuestEquipTalismans"] =
	{
		TitleText = "Objective_QuestPassives01",
		GlobalRequiredFlag = "QuestEquipTalismans",
		OnGivenFunction = "CheckTalismanQuest",
		MapObjectType = "Caravan",
		Campaign = true,
		CampaignPriority = 3,
		ShowProgress = true,
		CampaignTurnIn = true,
		CompletionEvent = "BardQuest_01_Completed",
	},
	["QuestExilesLevel2"] =
	{
		TitleText = "Objective_QuestExilesLevel2",
		GlobalRequiredFlag = "QuestExilesLevel2",
		MapObjectType = "Caravan",
		Campaign = true,
		CampaignPriority = 3,
		CampaignExileLevelCount = true,
		CampaignTurnIn = true,
		CompletionEvent = "BardQuest_02_Completed",
	},
	["QuestExilesLevel5"] =
	{
		TitleText = "Objective_QuestExilesLevel5",
		GlobalRequiredFlag = "QuestExilesLevel5",
		MapObjectType = "Caravan",
		Campaign = true,
		CampaignPriority = 3,
		CampaignExileLevelCount = true,
		CampaignTurnIn = true,
	},
	["QuestCoachLevel2"] =
	{
		TitleText = "Objective_QuestCoachLevel2",
		GlobalRequiredFlag = "QuestCoachLevel2",
		MapObjectType = "Caravan",
		Campaign = true,
		CampaignPriority = 3,
		CampaignCoachLevelCount = true,
		CampaignTurnIn = true,
		CompletionEvent = "BardQuest_03_Completed",
		MaxCount = 2,
	},

	["QuestContact"] =
	{
		TitleText = "Objective_QuestContact01",
		GlobalRequiredFlag = "QuestContact",
		MapObjectType = "KnownLocation",
		MapObjectLocationIds = { 10009 },
		Campaign = true,
		CampaignPriority = 3,
	},

	-- Personal Quests
	["QuestFriend"] =
	{
		TitleText = "Objective_QuestFriend01",
		GlobalRequiredFlag = "QuestFriend",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestBadass"] =
	{
		TitleText = "Objective_QuestBadass01",
		GlobalRequiredFlag = "QuestBadass",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestJoker"] =
	{
		TitleText = "Objective_QuestJoker01",
		GlobalRequiredFlag = "QuestJoker",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestPsycho"] =
	{
		TitleText = "Objective_QuestPsycho01",
		GlobalRequiredFlag = "QuestPsycho",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestMascot"] =
	{
		TitleText = "Objective_QuestMascot01",
		GlobalRequiredFlag = "QuestMascot",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestKnight"] =
	{
		TitleText = "Objective_QuestKnight01",
		GlobalRequiredFlag = "QuestKnight",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestVamp"] =
	{
		TitleText = "Objective_QuestVamp01",
		GlobalRequiredFlag = "QuestVamp",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestDoc"] =
	{
		TitleText = "Objective_QuestDoc01",
		GlobalRequiredFlag = "QuestDoc",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestDiva"] =
	{
		TitleText = "Objective_QuestDiva01",
		GlobalRequiredFlag = "QuestDiva",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestShopKeeper"] =
	{
		TitleText = "Objective_QuestShopKeeper01",
		GlobalRequiredFlag = "QuestShopKeeper",
		Campaign = true,
		CampaignPriority = 5,
	},

	["QuestWagon"] =
	{
		TitleText = "Objective_QuestWagon01",
		GlobalRequiredFlag = "QuestWagon",
		Campaign = true,
		CampaignPriority = 5,
	},

	-- MP Objectives
	["StartLocalMP"] =
	{
		TitleText = "Objective_StartLocalMP",
		NumCompletions = 0,
		GlobalRequiredFlag = "StartLocalMP",
	},

	["StartNetMP"] =
	{
		TitleText = "Objective_StartNetMP",
		NumCompletions = 0,
		GlobalRequiredFlag = "StartNetMP",
	},

	["MatchmakingMP"] =
	{
		TitleText = "Objective_MatchmakingMP0",
	},

	-- Examples

	["QuestForageFromPrarieNodes"] =
	{
		TitleText = "Objective_ForageFromPrarieNodes",
		Campaign = true,
		CampaignTurnIn = true,
		ShowProgress = true,
		Type = "Forage",
		GoalName = "Prairie_Plains",
		CompletionEvent = "BardQuest_07_Completed",
		MaxCount = 3,
	},

	["QuestUnlockGuideBookChapters"] =
	{
		TitleText = "Objective_UnlockGuideBookChapters",
		Campaign = true,
		CampaignTurnIn = true,
		ShowProgress = true,
		MaxCount = 10,
	},

	["QuestStockpileFuel"] =
	{
		TitleText = "Objective_StockpileFuel",
		Campaign = true,
		CampaignTurnIn = true,
		ShowProgress = true,
		CompletionEvent = "BardQuest_04_Completed",
		MaxCount = 100,
	},

	["QuestFindGilmanTalisman"] =
	{
		TitleText = "Objective_FindGilmanTalisman",
		Campaign = true,
		CampaignTurnIn = true,
		CompletionEvent = "BardQuest_05_Completed",
		Type = "AcquireItem",
		GoalName = "UniqueTrailItem01",
		MaxCount = 1,
	},

	["AchieveJodiHope"] =
	{
		TitleText = "Objective_AchieveHope",
		Campaign = true,
		CampaignTurnIn = true,
		ShowProgress = true,
		Type = "StatValue",
		GoalName = "PlayerAttributeRespawn",
		GoalCharacterTag = "Story_Badass",
		MaxCount = 12,
	},

	-- Open Structure Bard Objectives

	["DoubleKill"] =
	{
		TitleText = "PracticeDoubleKill",
		MinMatchRequirement = 0,
		Reward = 20,
	},

	["NoKillScore"] =
	{
		TitleText = "PracticeNoKillScore",
		MinMatchRequirement = 0,
		Reward = 35,
	},

	["NoDeathScore"] =
	{
		TitleText = "PracticeNoDeathScore",
		MinMatchRequirement = 0,
		Reward = 40,
	},

	["NoPassScore"] =
	{
		TitleText = "Objective_NoPassScore",
		MinMatchRequirement = 0,
		Reward = 30,
	},

	["TauntScore"] =
	{
		TitleText = "Objective_TauntScore",
		MinMatchRequirement = 0,
		Reward = 45,
		AltRewardMessage = true,
	},

	["GeneratedKillTeam"] =
	{
		TitleText = "Objective_GeneratedKillTeam",
		MinMatchRequirement = 0,
		GeneratedCountMin = 10,
		GeneratedCountMax = 20,
		ShowProgress = true,
		Reward = 10,
	},

	["GeneratedKillUnique"] =
	{
		TitleText = "Objective_GeneratedKillUnique",
		MinMatchRequirement = 0,
		GeneratedCountMin = 2,
		GeneratedCountMax = 8,
		GeneratedTeamMember = true,
		ShowProgress = true,
		Reward = 20,
	},

	["GeneratedScore"] =
	{
		TitleText = "Objective_GeneratedScore",
		MinMatchRequirement = 0,
		GeneratedTeamMember = true,
		GeneratedCountMin = 1,
		GeneratedCountMax = 1,
		Reward = 20,
	},
	["GeneratedSacrificeScore"] =
	{
		TitleText = "Objective_GeneratedSacrificeScore",
		MinMatchRequirement = 0,
		GeneratedTeamMember = true,
		GeneratedCountMin = 1,
		GeneratedCountMax = 1,
		Reward = 25,
	},
	["GeneratedThrowScore"] =
	{
		TitleText = "Objective_GeneratedThrowScore",
		MinMatchRequirement = 0,
		GeneratedTeamMember = true,
		GeneratedCountMin = 1,
		GeneratedCountMax = 1,
		Reward = 15,
	},
}

OnAnyLoad
{
	function( triggerArgs )
		-- match objective stuff
		MatchObjectiveScoringArchetypes = { }

		ActiveObjectives = ActiveObjectives or { }
		PersistVariable({ Name = "ActiveObjectives" })

		ClearNonCampaignObjectives()
		SetupObjectiveLog()
	end
}

function SetupObjectiveDisplay()

	if objectiveSetup then
		return
	end
	objectiveSetup = true

	matchObjectiveAnchor = SpawnObstacle({ Name = "InvisibleTarget", Group = "Scripting", DestinationName = "Player" })
	DrawScreenRelative({ Id = matchObjectiveAnchor })
	Teleport({ Id = matchObjectiveAnchor, OffsetX = 1920/2, OffsetY = 1080 - 280 })

	matchObjectiveBackground = SpawnObstacle({ Name = "Auden_Blank_01", Group = "Scripting", DestinationName = "Player" })
	DrawScreenRelative({ Id = matchObjectiveBackground })
	Teleport({ Id = matchObjectiveBackground, OffsetX = 1920/2, OffsetY = 1080 + 200 })
	SetScale({ Id = matchObjectiveBackground, Fraction = 10, Duration = 0 })
	SetColor({ Id = matchObjectiveBackground, Color = Color.Black, Duration = 0 })
	SetOpacity({ Id = matchObjectiveBackground, Fraction = 0.5, Duration = 0 })

end

function SetupObjectiveLog()

	ObjectiveAnchorIds = { }

	local matchAnchorBufferY = 70
	if GetMapName({ }) == "Campaign" then
		matchAnchorBufferY = 250
	end

	local objectiveLimit = 30
	for index = 1, objectiveLimit, 1 do
		local matchObjectiveLogAnchorObjectId = SpawnObstacle({ Name = "InvisibleTarget", Group = "MatchAnchors", DestinationName = "Player" })
		DrawScreenRelative({ Id = matchObjectiveLogAnchorObjectId })

		Teleport({ Id = matchObjectiveLogAnchorObjectId, OffsetX = 130, OffsetY = 100 + matchAnchorBufferY })
		matchAnchorBufferY = matchAnchorBufferY + 40
		ObjectiveAnchorIds[index] = matchObjectiveLogAnchorObjectId
	end
	DrawScreenRelative({ Names = "MatchAnchors" })

	ReassignAnchors()
	HideObjectiveLog()

end

function ClearNonCampaignObjectives()
	for key, objective in pairs( ActiveObjectives ) do
		local objectiveData = GetObjectiveData( objective.Name )
		if not objectiveData.Campaign then
			ActiveObjectives[key] = nil
		end
	end
end

function DisplayObjective( matchObjectiveKey, initialCount )

	local matchObjectiveData = GetObjectiveData( matchObjectiveKey )
	if matchObjectiveData == nil then
		DebugPrint({ Text = "No objective data." })
		return
	end

	if HasActiveObjective( matchObjectiveKey ) then
		DebugPrint({ Text = "Objective already active." })
		return
	end

	-- While displaying one objective at a time, wait until previously completed objective finishes clearing
	if markingObjectiveComplete then
		waitUntil("finishMarkingObjectiveComplete")
	end

	if showingObjective then
		return
	end
	showingObjective = true

	if matchObjectiveData.GlobalRequiredFlag then
		SetFlagTrue({ Name = matchObjectiveData.GlobalRequiredFlag })
	end

	if matchObjectiveData.TitleText == nil then
		matchObjectiveData.TitleText = matchObjectiveKey
	end

	local activeObjective = ShallowCopyTable( matchObjectiveData )
	activeObjective.Name = matchObjectiveKey
	activeObjective.Status = "Active"
	activeObjective.CurrentCount = initialCount
	activeObjective.MaxCount = matchObjectiveData.MaxCount
	activeObjective.Type = matchObjectiveData.Type
	if matchObjectiveData.GeneratedCountMin ~= nil and matchObjectiveData.GeneratedCountMax ~= nil then
		activeObjective.MaxCount = math.random( matchObjectiveData.GeneratedCountMin, matchObjectiveData.GeneratedCountMax )
	end
	if matchObjectiveData.GeneratedTeamMember ~= nil then
		activeObjective.GeneratedMember = GetRandomDraftedCharacter( PlayerTeam )
	end

	AddActiveObjective( activeObjective )

	if matchObjectiveData.OnGivenFunction ~= nil then
		local onGivenFunction = _G[matchObjectiveData.OnGivenFunction]
		if onGivenFunction ~= nil then
			onGivenFunction()
		end
	end

	-- hide this in Trailer Mode (normally this option is true)
	if GetConfigOptionValue({ Name = "ShowUIAnimations" }) then
		PlaySound({ Name = "/SFX/Menu Sounds/ChoirShort" })

		objectiveLogVisible = true

		local objectiveText = GetObjectiveText( activeObjective )
		SetScale({ Id = activeObjective.AnchorId, Fraction = 1.0 })
		SetOpacity({ Id = activeObjective.AnchorId, Fraction = 1.0 })
		DisplayObjectiveBacking( activeObjective.AnchorId )

		local textColor = Color.White
		if activeObjective.CampaignPriority ~= nil then
			if activeObjective.Campaign and activeObjective.CampaignPriority >= 2 then
				textColor = Color.LightGray
			end
		end

		--Attached for initial presentation, to keep text location aligned with background animation while scaling
		local textDestination = SpawnObstacle({ Name = "InvisibleTarget", Group = "Scripting", DestinationName = "Player" })
		DrawScreenRelative({ Id = textDestination })
		Teleport({ Id = textDestination, DestinationId = activeObjective.AnchorId, OffsetX = 44, OffsetY = 17 })

		DisplayWorldText({ Id = textDestination, Group = "Overlay", Text = objectiveText, Justification = "Left",
			ShadowBlur = 1,
			ShadowColor = {0.113, 0.113, 0.113, 1},
			ShadowOffset = {0, 1},
			OutlineThickness = 0,
			OutlineColor = {0.113, 0.113, 0.113, 1},
			Color = textColor,
			Font="AlegreyaSCBold40",
			Scale = 1,
			CharFadeTime = .02,
			CharFadeInterval = .02,
			CharFadeColor = Color.Gold,
			CharFadeColorLag = .25,
			LuaKey = "CurrentObjective",
			LuaData = activeObjective,
			TextSymbolScale = 0.8,
		})

		wait(1)

		PlaySound({ Name = "/SFX/World Sounds/MapZoomInTight" })

		local scaleObjectiveDuration = .36
		Move({ Id = textDestination, DestinationId = activeObjective.AnchorId, Duration = scaleObjectiveDuration, SmoothStep = true })
		UpdateWorldText({ Id = textDestination, Scale = 0.5, ScaleDuration = scaleObjectiveDuration, SmoothStep = true})
		SetScale({ Id = activeObjective.AnchorId, Fraction = 0.5, SmoothStep = true, Duration = scaleObjectiveDuration})

		wait(scaleObjectiveDuration)

		RemoveWorldText({ DestinationId = textDestination})
		local objectiveText = GetObjectiveText( activeObjective ) -- Could have been updated by now
		DisplayWorldText({ Id = activeObjective.AnchorId, Group = "Overlay", Text = objectiveText, Justification = "Left",
			ShadowBlur = 1,
			ShadowColor = {0.113, 0.113, 0.113, 1},
			ShadowOffset = {0, 1},
			OutlineThickness = 0,
			OutlineColor = {0.113, 0.113, 0.113, 1},
			StartOpacity = 1,
			Color = textColor,
			Font="AlegreyaSCBold40",
			Scale = .5,
			TextSymbolScale = 0.8,
		})
	end

	notifyExistingWaiters("matchLogFullyUpdated")
	showingObjective = false

end

function GetObjectiveText( objective )

	CurrentObjective = objective
	if objective.CurrentCount == nil then
		objective.CurrentCount = 0
	end
	local objectiveData = GetObjectiveData( objective.Name )

	local helpTextId = objectiveData.TitleText
	if objectiveData.CampaignDayCount then
		if movesAvailable == 1 then
			helpTextId = helpTextId.."_Tomorrow"
		elseif movesAvailable == 0 then
			helpTextId = helpTextId.."_Tonight"
		end
	end

	if objectiveData.CampaignTurnIn and objective.Status == "TurnIn" then
		helpTextId = helpTextId.."_TurnIn"
	end

	if objectiveData.ShowGoldBalance then
		helpTextId = helpTextId.."_GoldBalance"
	end

	local objectiveLogTitle = GetDisplayName({ Text = helpTextId })
	local progressString = ""
	if objectiveData.ShowProgress then
		progressString = " ("..objective.CurrentCount.."/"..objective.MaxCount..")"
	end

	if objectiveData.Reward then
		local rewardAmount = tostring(objective.Reward)
		if objectiveData.AltRewardMessage then
			progressString = ": "..rewardAmount.."   {!Icons.Gold}"
		else
			progressString = ": "..rewardAmount.."{!Icons.Gold}"
		end
	end

	local text = objectiveLogTitle..progressString
	return text

end

function GetObjectiveData( objectiveName )

	local data = MatchObjectives[objectiveName]
	if data ~= nil then
		return data
	end

	return nil

end

function DisplayObjectiveBacking( anchorId )

	if not GetConfigOptionValue({ Name = "ShowUIAnimations" }) then
		return
	end

	PlayOverheadAnimation({ Name = "MatchObjectiveBGIn",
			DestinationId = anchorId,
			IgnoreOverheadOffset = true,
			OffsetX =-42,
			OffsetY = -19,
			Scale = 2.0,
			Group = "Overlay",
		})

end

function AddActiveObjective( objective )

	local objectiveData = GetObjectiveData( objective.Name )
	if objectiveData.CampaignPriority ~= nil then
		for index, activeObjective in ipairs( ActiveObjectives ) do
			local activeObjectiveData = GetObjectiveData( activeObjective.Name )
			if activeObjectiveData.CampaignPriority == nil or objectiveData.CampaignPriority < activeObjectiveData.CampaignPriority then
				DebugPrint({ Text = "inserting at "..index })
				objective.AnchorId = ObjectiveAnchorIds[index]
				table.insert( ActiveObjectives, index, objective )
				ReassignAnchors( objective, true )
				return
			end
		end
	end

	local index = TableLength( ActiveObjectives ) + 1
	objective.AnchorId = ObjectiveAnchorIds[index]
	table.insert( ActiveObjectives, objective )

end

function ReassignAnchors( skipObjective, showBacking )
	local anchorIndex = 1

	-- Remove any old text first
	for k, objective in ipairs( ActiveObjectives ) do
		if objective ~= skipObjective then
			RemoveWorldText({ DestinationId = objective.AnchorId })
		end
	end

	for k, objective in pairs( ActiveObjectives ) do

		if objective ~= skipObjective then
			objective.AnchorId = ObjectiveAnchorIds[anchorIndex]

			local objectiveData = GetObjectiveData( objective.Name )

			-- Backwards compatibility
			objective.TitleText = objectiveData.TitleText

			local objectiveText = GetObjectiveText( objective )
			SetScale({ Id = objective.AnchorId, Fraction = 0.5, Duration = 0 })
			DisplayWorldText({ Id = objective.AnchorId, Group = "Overlay", Text = objectiveText, Justification = "Left",
				ShadowBlur = 1,
				ShadowColor = {0.113, 0.113, 0.113, 1},
				ShadowOffset = {0, 1},
				OutlineThickness = 0,
				OutlineColor = {0.113, 0.113, 0.113, 1},
				StartOpacity = 1,
				Color = Color.White,
				Font="AlegreyaSCBold40",
				Scale = .5,
				StartOpacity = 0.0,
				TextSymbolScale = 0.8,
			})
			if showBacking then
				DisplayObjectiveBacking( objective.AnchorId )
			end
		end

		anchorIndex = anchorIndex + 1

	end
end

function HasActiveObjective( objectiveName )
	for k, objective in pairs( ActiveObjectives ) do
		if objective.Name == objectiveName then
			return true
		end
	end
	return false
end

function HasActiveObjectiveGoal( goalName )
	for k, objective in pairs( ActiveObjectives ) do
		if GetGoalName( objective ) == goalName then
			return true
		end
	end
	return false
end

function UpdateObjectiveTypeProgress( type, goalName, character, currentCount )

	for k, objective in pairs( ActiveObjectives ) do
		local objectiveData = GetObjectiveData( objective.Name )
		if objectiveData.Type == type and GetGoalName( objective ) == goalName then
			if character == nil or character.Tags[objectiveData.GoalCharacterTag] then
				UpdateActiveObjectiveProgress( objective, character, currentCount )
			end
		end
	end

end

function UpdateObjectiveProgress( matchObjectiveKey, character, currentCount, maxCount, addCount )

	local objective = GetActiveObjective( matchObjectiveKey )
	if objective == nil then
		return
	end

	UpdateActiveObjectiveProgress( objective, character, currentCount, maxCount, addCount )

end

function UpdateActiveObjectiveProgress( objective, character, currentCount, maxCount, addCount )

	if objective.Status == "Complete" then
		return
	end

	if objective.GeneratedMember ~= nil and objective.GeneratedMember ~= character then
		return
	end

	if objective.CurrentCount == nil then
		objective.CurrentCount = 0
	end

	local objectiveData = GetObjectiveData( objective.Name )

	if objectiveData.ItemName ~= nil and objective.ItemName ~= character then
		return
	end

	local autoIncrement = true
	if currentCount ~= nil then
		if addCount then
			objective.CurrentCount = objective.CurrentCount + currentCount
		else
			objective.CurrentCount = currentCount
		end
		autoIncrement = false
	end
	if maxCount ~= nil then
		objective.MaxCount = maxCount
		autoIncrement = false
	end

	if autoIncrement and objective.MaxCount ~= nil and objective.CurrentCount < objective.MaxCount then
		objective.CurrentCount = objective.CurrentCount + 1
	end

	if objective.MaxCount ~= nil and objective.CurrentCount >= objective.MaxCount then
		additionalTutorialObjectiveActive = false
		if objectiveData.CampaignTurnIn then
			objective.Status = "TurnIn"
		elseif objectiveLogVisible then
			thread( MarkObjectiveComplete, objective.Name )
		else
			PrepareMarkObjectiveComplete( objective.Name )
		end
	else
		PlaySound({ Name = "/SFX/Menu Sounds/StorePickupItem" })
	end

	local objectiveText = GetObjectiveText( objective )
	if objective.MaxCount ~= nil and objective.CurrentCount >= objective.MaxCount then
		UpdateWorldText({ Id = objective.AnchorId, Text = objectiveText, MarkDity = true })
	else
		UpdateWorldText({ Id = objective.AnchorId, Text = objectiveText, MarkDity = true, Color = Color.Gold  })
		thread( ObjectiveColorDelay, objective, objectiveData, objectiveText )
	end

end

function ObjectiveColorDelay( objective, objectiveData, objectiveText )
	wait(0.3)
	if objective.Status ~= "Complete" then
		UpdateWorldText({ Id = objective.AnchorId, Text = objectiveText, MarkDity = true, Color = { 254, 254, 254, 255 } })
	end
end

function GetActiveObjective( objectiveName )

	for k, activeObjective in pairs( ActiveObjectives ) do
		if activeObjective.Name == objectiveName then
			return activeObjective
		end
	end

	return nil

end

function GetActiveObjectiveWithGoalId( nodeId )

	for k, activeObjective in pairs( ActiveObjectives ) do
		if activeObjective.GoalId == nodeId then
			return activeObjective
		end
	end

	return nil

end

function MarkObjectiveFailed( objectiveKey )

	local objective = GetActiveObjective( objectiveKey )
	if objective == nil or objective.Failed then
		return
	end
	objective.Failed = true

	local matchObjectiveData = GetObjectiveData( objectiveKey )

	StopAnimation({ Names = "MatchObjectiveBGIn", DestinationId = objective.AnchorId })
	PlayOverheadAnimation({
			Name = "MatchObjectiveBGOutFailed",
			DestinationId = objective.AnchorId, OffsetX =-42, OffsetY = -19,
			IgnoreOverheadOffset = true,
			Scale = 2,
			Group = "Overlay"
	})

end

function MarkObjectiveUnfailed( objectiveKey )

	local objective = GetActiveObjective( objectiveKey )
	if objective == nil or not objective.Failed then
		return
	end
	objective.Failed = false

	local matchObjectiveData = GetObjectiveData( objectiveKey )

	StopAnimation({ Names = "MatchObjectiveBGOutFailed", DestinationId = objective.AnchorId })
	PlayOverheadAnimation({
			Name = "MatchObjectiveBGIn",
			DestinationId = objective.AnchorId, OffsetX =-42, OffsetY = -19,
			IgnoreOverheadOffset = true,
			Scale = 2,
			Group = "Overlay"
	})

end

OnAnyLoad
{
	function( triggerArgs )
		FeatsOfGloryComplete = FeatsOfGloryComplete or 0
		PersistVariable({ Name = "FeatsOfGloryComplete" })
	end
}

function MarkObjectiveComplete( matchObjectiveKey )

	local objective = GetActiveObjective( matchObjectiveKey )
	if objective == nil then
		return
	end

	local matchObjectiveData = GetObjectiveData( matchObjectiveKey )

	markingObjectiveComplete = true

	if matchObjectiveData.GlobalRequiredFlag then
		SetFlagFalse({ Name = matchObjectiveData.GlobalRequiredFlag })
	end

	objective.Status = "Complete"

	if GetConfigOptionValue({ Name = "ShowUIAnimations" }) then
		if objective.Reward then
			--PlaySound({ Name = "/SFX/Menu Sounds/MakingMoneyChaChing" }) -- this is done in RewardFeedback
		else
			PlaySound({ Name = "/SFX/Match SFX/AnnouncementPing2", Id = objective.AnchorId })
		end

		StopAnimation({ Names = "MatchObjectiveBGIn", DestinationId = objective.AnchorId })
		PlayOverheadAnimation({
				Name = "MatchObjectiveBGOut",
				DestinationId = objective.AnchorId, OffsetX =-42, OffsetY = -19,
				IgnoreOverheadOffset = true,
				Scale = 2,
				Group = "Overlay"
		})
		UpdateWorldText({ Id = objective.AnchorId, Color = {0.3, 0.3, 0.3} })
	end

	if objective.Reward ~= nil then
		DepositMoney( objective.Reward )
		thread( GiveRewardFeedback, objective.Reward )
		FeatsOfGloryComplete = FeatsOfGloryComplete + 1
		if FeatsOfGloryComplete >= 3 then
			UnlockAchievementOnce( "AchQuests5" )
		end
	end

	wait(1.3)
	SlideObjectiveLogUp( objective )

	markingObjectiveComplete = false
	notifyExistingWaiters( "finishMarkingObjectiveComplete" )
	objective.Status = "Cleared"

	if matchObjectiveData.NextObjectiveUp ~= nil then
		if matchObjectiveData.NextObjectiveUpWait ~= nil and matchObjectiveData.NextObjectiveUpWait > 0 then
			wait(matchObjectiveData.NextObjectiveUpWait)
		end
		DisplayObjective( matchObjectiveData.NextObjectiveUp )
	end

end

function GiveRewardFeedback( purse )

	wait(0.01)

	local currentRewardUnit = GetActiveUnitId({ PlayerIndex = 1 })
	LatestPurse = purse

	PlaySound({ Name = "/SFX/Match SFX/ImpCrowdCheer", Delay = 0.1, Id = excitedImp })

	local excitedImp = SpawnObstacle({ Name = "RewardImpInTheCrowd", Group = "ScreenOverlay", DestinationId = ballId })
	local excitedImp2 = SpawnObstacle({ Name = "ImpFlag_J_", Group = "ScreenOverlay", DestinationId = ballId })
	local excitedImp3 = SpawnObstacle({ Name = "ImpFlag_J_", Group = "ScreenOverlay", DestinationId = ballId })
	local excitedImp4 = SpawnObstacle({ Name = "ImpFlag_J_", Group = "ScreenOverlay", DestinationId = ballId })
	local excitedImp5 = SpawnObstacle({ Name = "ImpFlag_J_", Group = "ScreenOverlay", DestinationId = ballId })
	local excitedImps = { excitedImp, excitedImp2, excitedImp3, excitedImp4, excitedImp5 }
	local excitedImpFeedbackPoint = SpawnObstacle({ Name = "InvisibleTarget", Group = "ScreenOverlay", DestinationId = excitedImp })
	Attach({ Id = excitedImpFeedbackPoint, DestinationId = excitedImp, OffsetY = -1000 })
	SetOpacity({ Ids = excitedImps, Fraction = 0 })
	SetScale({ Ids = excitedImps, Fraction = 0.01 })
	Teleport({ Ids = excitedImps, OffsetX = 1920/2, OffsetY = (1080/2) + 850 })
	DrawScreenRelative({ Ids = excitedImps })
	SetGoalAngle({ Ids = excitedImps, Angle = 90 })
	wait(0.1)
	SetScale({ Ids = excitedImps, Fraction = 2.0 })
	SetOpacity({ Ids = excitedImps, Fraction = 2.0 })
	SetColor({ Ids = excitedImps, Color = Color.Black })
	Move({ Id = excitedImp, Speed = 300, Angle = 90 })
	Move({ Id = excitedImp2, Speed = 800, Angle = 120 })
	Move({ Id = excitedImp3, Speed = 700, Angle = 60 })
	Move({ Id = excitedImp4, Speed = 500, Angle = 110 })
	Move({ Id = excitedImp5, Speed = 600, Angle = 110 })
	Stop({ Ids = excitedImps, Delay = 0.5 })
	wait(0.85)
	local feedbackFloater = SpawnObstacle({ Name = "InvisibleTarget", Group = "ScreenOverlay", DestinationId = excitedImp, OffsetY = -600 })
	DrawScreenRelative({ Id = feedbackFloater })
	--PlayOverheadAnimation({ Name = "OnUnitFeedbackFx", DestinationId = feedbackFloater, IgnoreOverheadOffset = true })
	DisplayWorldText({ Id = feedbackFloater,
			Text = "MatchMessage_ObjectiveReward",
			Justification = "CENTER",
			ShadowBlur = 0,
			ShadowColor = {0.103, 0.097, 0.093, 0.9},
			ShadowOffset = {0, 2},
			OutlineThickness = 1.0,
			OutlineColor = {0.167, 0.139, 0.095, 1.0},
			StartOpacity = 1.0,
			Font="AlegreyaSCBoldTracking",
			FontSize = 26,
			TimeModifierFraction = 0.0,
			TextSymbolScale = 0.8,
			})
	UpdateWorldText({ Id = feedbackFloater, Scale = 6.50, ScaleDuration = 0.00, Color = Color.White })
	local textColor = {0.898, 0.886, 0.820, 1.0}
	UpdateWorldText({ Id = feedbackFloater, Scale = 3.00, ScaleDuration = 0.05, Color = textColor, ColorChangeSpeed = 2.0  })

	Move({ Id = feedbackFloater, Angle = 90, Speed = 25 })
	PlaySound({ Name = "/SFX/Menu Sounds/MakingMoneyChaChing" })
	wait(0.5)
	RemoveWorldText({ DestinationId = feedbackFloater, Duration = 0.10 })

	Move({ Id = excitedImp, Speed = 200, Angle = 270, Delay = 0.3 })
	Move({ Id = excitedImp2, Speed = 230, Angle = 270, Delay = 0.3 })
	Move({ Id = excitedImp3, Speed = 230, Angle = 270, Delay = 0.5 })
	Move({ Id = excitedImp4, Speed = 230, Angle = 270, Delay = 0.8 })
	Move({ Id = excitedImp5, Speed = 230, Angle = 270, Delay = 1.1 })

	--wait(1.0)
	wait(2.0)
	Delete({ Ids = excitedImps })
	Delete({ Id = feedbackFloater })
end

OnKeyPressed{"Control O",
	function(triggerArgs)
		GiveRewardFeedback( 30 )
	end
}

function SlideObjectiveLogUp( objective )

	local foundCompletedObjective = false

	local totalDistance = 40
	local totalDuration = 0.4

	local slideDuration = 0.33
	local slideDistance = 5
	local animationsToStop = { "CombatOver_Checkoff", "ActivePowerHighlight", "MatchObjectiveBGIn", "MatchObjectiveBGOut" }

	--for k, activeObjective in pairs( ActiveObjectives ) do
	for k, anchorId in pairs( ObjectiveAnchorIds ) do

		if anchorId == objective.AnchorId then
			foundCompletedObjective = true

			SetOpacity({ Id = objective.AnchorId, Fraction = 0, Duration = slideDuration })
			UpdateWorldText({ Id = objective.AnchorId, FadeTarget = 0, Duration = slideDuration })

			StopAnimation({ Names = animationsToStop, DestinationId = objective.AnchorId, Delay = slideDuration })
			RemoveWorldText({ DestinationId = objective.AnchorId, Delay = slideDuration })

			StopAnimation({ Names = animationsToStop, DestinationId = objective.AnchorId, Delay = slideDuration })

		elseif foundCompletedObjective then
			Move({ Id = anchorId, DestinationId = anchorId, OffsetY = -totalDistance, Speed = totalDistance / totalDuration })
		end
	end

	-- Throw the anchor of the completed objective
	RemoveValue( ObjectiveAnchorIds, objective.AnchorId )
	ObjectiveAnchorIds = CollapseTable( ObjectiveAnchorIds )

	wait(totalDuration)
	RemoveValue( ActiveObjectives, objective )

end

function ShimmerUnfinishedObjectives()
	while true do
		wait(10)
		local numActiveObjectives = 0
		for k, activeObjective in pairs( ActiveObjectives ) do
			if activeObjective.Status == "Active" then
				--[[
				UpdateWorldText({ Text = v.TitleText, Id = v.LogPosition,
						Color = Color.DarkOrange })

				UpdateWorldText({ Text = v.TitleText, Id = v.LogPosition,
						Color = { 254, 254, 254, 254 }, Delay = 0.5 })

				Move({ Id = v.LogPosition, Speed = 300, Angle = 0, Duration = 0.075 })
				Move({ Id = v.LogPosition, Speed = 300, Angle = -180, Duration = 0.075, Delay = 0.075 })
				Stop({ Id = v.LogPosition, Delay = 0.15 })
				]]

				PlayOverheadAnimation({
						Name = "ActivePowerHighlight",
						DestinationId = activeObjective.AnchorId, OffsetX = -30, OffsetY = 2,
						IgnoreOverheadOffset = true,
						Scale = 0.40,
				})

				StopAnimation({ Name = "ActivePowerHighlight", DestinationId = activeObjective.AnchorId, Duration = 0.35, Delay = 1.5 })

				numActiveObjectives = numActiveObjectives + 1
			end
		end
		if numActiveObjectives == 0 then
			break
		end

		local randomObjectiveShimmerWait = math.random(15, 20)
		wait(randomObjectiveShimmerWait)
	end
end

OnAnyLoad
{
	function( triggerArgs )
		PickedOpenObjectives = PickedOpenObjectives or { }
		PersistVariable({ Name = "PickedOpenObjectives" })
	end
}

local matchObjectives = { "DoubleKill", "NoKillScore", "NoDeathScore", "NoPassScore", "TauntScore", "GeneratedTeamKill", "GeneratedKillUnique", "GeneratedScore", "GeneratedSacrificeScore", "GeneratedThrowScore" }

function PickMatchObjective()

	if not allowCaravanFly then
		return
	end

	if ChallengeData ~= nil or introMatch or practiceMatch or uncommonMatch or not objectiveSystemUnlocked or IsAscensionWeek() then
		return
	end

	if IsMultiplayerMatch() then
		return
	end

	if rewardOjectivePicked then
		return
	end

	if IsMatchObjectiveActive() then
		return
	end

	-- Pick a generated objective
	local pickedObjective = GetRandomRemainingEvent( matchObjectives )
	if pickedObjective ~= nil then
		rewardOjectivePicked = true
		DisplayObjective( pickedObjective )
	end

	return pickedObjective
end

function IsMatchObjectiveActive()
	for k, objective in pairs( ActiveObjectives ) do
		if not objective.Campaign then
			return true
		end
	end
	return false
end

function CreateLegalPracticeMatchObjectivesTable( filterType )
	local mapName = GetMapName({ })
	local legalPracticeMatchObjectives = { }
	for k, v in pairs( MatchObjectives ) do
		--if v.Status ~= "Complete" and v.Type == filterType then
		if IsObjectiveLegal( v, filterType, mapName, k ) then
			legalPracticeMatchObjectives[k] = v
		end
	end
	return legalPracticeMatchObjectives
end

function IsObjectiveLegal( matchObjective, filterType, mapName, objectiveKey )

	if matchObjective.Status == "Complete" then
		return false
	end

	if matchObjective.Type == nil or matchObjective.Type ~= filterType then
		return false
	end

	if PickedOpenObjectives[objectiveKey] then
		return false
	end

	if matchObjective.RequiredLivingArchetype ~= nil then
		local archetypeFound = false
		for k, v in pairs(TeamA.TeamBench) do
			if CheckUnitAlive (v.ObjectId) and v.Archetype == matchObjective.RequiredLivingArchetype then
				archetypeFound = true
			end
		end
		if not archetypeFound then
			return false
		end
	end

	if matchObjective.RequiredLivingRivalArchetype ~= nil then
		local archetypeFound = false
		for k, v in pairs(TeamB.TeamBench) do
			if CheckUnitAlive (v.ObjectId) and v.Archetype == matchObjective.RequiredLivingArchetype then
				archetypeFound = true
			end
		end
		if not archetypeFound then
			return false
		end
	end

	if matchObjective.RequiredLivingMastery ~= nil then
		local archetypeFound = false
		for k, v in pairs(TeamA.TeamBench) do
			if CheckUnitAlive (v.ObjectId) and Contains(v.Skills, matchObjective.RequiredLivingMastery) then
				archetypeFound = true
			end
		end
		if not archetypeFound then
			return false
		end
	end

	if matchObjective.RequiredMapName ~= nil and matchObjective.RequiredMapName ~= mapName then
		return false
	end

	if matchObjective.RequiredRivalTeamIndex ~= nil and matchObjective.RequiredRivalTeamIndex ~= TeamB.LeagueIndex then
		return false
	end

	return true
end

function NumTeamScores( num )
	if TeamA.NumScores == nil then
		return false
	elseif TeamB.NumScores == nil then
		return false
	end

	if num >= (TeamA.NumScores + TeamB.NumScores) then
		return true
	end
	return false
end

OnAnyLoad
{
	function( triggerArgs )
		ProppedObjectiveQueue = ProppedObjectiveQueue or { }
		CompletedObjectiveQueue = CompletedObjectiveQueue or { }
		PersistVariable({ Name = "ProppedObjectiveQueue" })
		PersistVariable({ Name = "CompletedObjectiveQueue" })
	end
}

function PrepareDisplayObjective( objectiveKey )
	ProppedObjectiveQueue[objectiveKey] = true
end

function PrepareMarkObjectiveComplete( objectiveKey )
	CompletedObjectiveQueue[objectiveKey] = true
end

function CheckScoringAchievements( playerData, scoreValue )

	if IsMultiplayerMatch() then
		return
	end

	if scoreValue >= 40 then
		UnlockAchievementOnce( "AchSingleScore40" )
	end

	if playerData.PointsAllTime >= 200 then
		if playerData == CharJoker then
			UnlockAchievementOnce( "AchRukeyDamage" )
		elseif playerData == CharFriend then
			UnlockAchievementOnce( "AchHedwynDamage" )
		elseif playerData == CharBadass then
			UnlockAchievementOnce( "AchJodiDamage" )
		elseif playerData == CharPsycho then
			UnlockAchievementOnce( "AchMaeDamage" )
		elseif playerData == CharMascot then
			UnlockAchievementOnce( "AchTizoDamage" )
		elseif playerData == CharKnight then
			UnlockAchievementOnce( "AchGilmanDamage" )
		elseif playerData == CharVamp then
			UnlockAchievementOnce( "AchPamithaDamage" )
		elseif playerData == CharDiva then
			UnlockAchievementOnce( "AchBertrudeDamage" )
		elseif playerData == CharDoc then
			UnlockAchievementOnce( "AchVolfredDamage" )
		end
	end
end

function CheckScoringObjectiveProgress( playerData )

	MatchObjectiveScoringArchetypes[playerData.FirstName] = true

	UpdateObjectiveProgress( "GeneratedScore", playerData )
	if SacrificeScorer ~= nil then
		UpdateObjectiveProgress( "GeneratedSacrificeScore", playerData )
	end
	if ThrowScorer ~= nil then
		UpdateObjectiveProgress( "GeneratedThrowScore", playerData )
	end
	if PlayerTeam.RoundKills == 0 then
		thread( MarkObjectiveComplete, "NoKillScore" )
	end
	if PlayerTeam.RoundDeaths == 0 then
		thread( MarkObjectiveComplete, "NoDeathScore" )
	end
	if PlayerTeam.PassesSincePickup == 0 then
		thread( MarkObjectiveComplete, "NoPassScore" )
	end
	if PlayerTeam.LastTauntTime + 5 > _worldTime then
		thread( MarkObjectiveComplete, "TauntScore" )
	end

end

local legalTrailKillingWeapons = ToLookup({ "ResetAura", "ResetAuraLarge", "ResetAuraSmall", "ResetAuraImp" })

function CheckKillingObjectiveProgress( killingPlayer, deadPlayer, deathWeapon )

	UpdateObjectiveProgress( "GeneratedKillTeam" )
	UpdateObjectiveProgress( "GeneratedKillUnique", killingPlayer )

	if deadPlayer ~= nil and deadPlayer.Archetype == "PlayerMonster" then
		UpdateObjectiveProgress( "DefeatingCrones01", deadPlayer, deadPlayer.BaseRespawnTimer, nil, true )
	end

	if deadPlayer ~= nil and deadPlayer.Archetype == "PlayerTrail" and legalTrailKillingWeapons[deathWeapon] then
		UpdateObjectiveProgress( "DefeatingTrails01" )
	end

end

function CheckJumpingObjectiveProgress( attacker, victim )
	if victim ~= nil and victim.Archetype == "PlayerFlying" and victim.FirstName ~= "Chars_Vamp_FirstName" then
		UpdateObjectiveProgress( "DefeatingFlying01" )
	end
end

-- Match Objective Completion Criteria

-- Tutorials
OnControlReleased{ "Pass",
	RequiredFlag = "PassTutorial",
	function(triggerArgs)
		SetFlagFalse({ Name = "PassTutorial" })
		-- thread( PlayIntroMatchSpeech, "passedtheball" )
		wait(0.4)
		MarkObjectiveComplete("PassTutorial")
		wait(1.15)
		local currentTutorialZoom = GetCameraZoom({ })
		PanCamera({ Id = 190001, Retarget = true, Duration = 1.5 })
		--FocusCamera({ Fraction = currentTutorialZoom * 1.1, Duration = 1.5, ZoomType = "Ease" })
		SetUnitProperty({ Name = "LegalPassTarget", Value = true, DestinationId = 190001 })
		DisplayObjective("PassHoldTutorial")
		SetFlagTrue({ Name = "PassHoldTutorial" })
	end
}

OnControlPressed{ "Sprint",
	RequiredFlag = "SprintTutorial",
	function(triggerArgs)
		if not IsInputAllowed({ PlayerIndex == 1 }) then
			return
		end

		MarkObjectiveComplete("SprintTutorial")
		wait(0.5)
		thread( PlayIntroMatchSpeech, "learn2sprint" )
		local currentTutorialZoom = GetCameraZoom({ })
		FocusCamera({ Fraction = currentTutorialZoom * 1.05, Duration = 1.5, ZoomType = "Ease" })
		DisplayObjective("StaminaTutorial")
		wait(0.35)
		--ShowControlsUITutorial()
	end
}

OnWeaponFired{ "JumpSmall JumpMedium JumpLarge",
	RequiredFlag = "JumpTutorial2",
	function(triggerArgs)
		if not IsInputAllowed({ PlayerIndex == 1 }) then
			return
		end

		UpdateObjectiveProgress( "JumpTutorial2" )
	end
}

OnControlReleased{ "Sprint",
	RequiredFlag = "SprintTutorial2",
	function(triggerArgs)
		if not IsInputAllowed({ PlayerIndex == 1 }) then
			return
		end

		UpdateObjectiveProgress( "SprintTutorial2" )
	end
}

OnDestroyAny{"TeamB",
	RequiredFlag = "CastTutorial2",
	function(triggerArgs)
		if not IsInputAllowed({ PlayerIndex == 1 }) then
			return
		end

		if triggerArgs.name == nil or not string.match( triggerArgs.name, "Cast" ) then
			return
		end

		UpdateObjectiveProgress( "CastTutorial2" )
	end
}

OnStaminaEmpty{
	RequiredFlag = "StaminaTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("StaminaTutorial")
		wait(0.5)
		FireTrigger({ Name = "EnemyPyreTutorial" })
	end
}

function FadeInOutline( objectId )
	for i = 0, 20 do
		local fraction = i * 0.05
		SetPlayerUnitProperty({ DestinationId = objectId, Name = "PhantomOutlineWidth", Value = Lerp( 0, PHANTOM_OUTLINE_WIDTH, fraction ), Delay = fraction * 0.4 })
		SetPlayerUnitProperty({ DestinationId = objectId, Name = "PhantomGradientTop", Value = Lerp( 0, PHANTOM_GRADIENT_TOP, fraction ), Delay = fraction * 0.4 })
		SetPlayerUnitProperty({ DestinationId = objectId, Name = "PhantomGradientBottom", Value = Lerp( 0, PHANTOM_GRADIENT_BOTTOM, fraction ), Delay = fraction * 0.4 })
	end
end

function FadeOutOutline( objectId )
	for i = 0, 20 do
		local fraction = i * 0.05
		SetPlayerUnitProperty({ DestinationId = objectId, Name = "PhantomOutlineWidth", Value = Lerp( PHANTOM_OUTLINE_WIDTH, 0, fraction ), Delay = fraction * 0.4 })
		SetPlayerUnitProperty({ DestinationId = objectId, Name = "PhantomGradientTop", Value = Lerp( PHANTOM_GRADIENT_TOP, 0, fraction ), Delay = fraction * 0.4 })
		SetPlayerUnitProperty({ DestinationId = objectId, Name = "PhantomGradientBottom", Value = Lerp( PHANTOM_GRADIENT_BOTTOM, 0, fraction ), Delay = fraction * 0.4 })
	end
end

function PostFirstScoreTutorial()
	if postFirstScoreTutorial then
		return
	end
	postFirstScoreTutorial = true

	midMatchEventLive = true

	thread(ShowInputDisabledPresentation)
	local sacrificeSubject = lastSacrificer
	FirstSacrificedUnit = SacrificeScorer
	PanCamera({ Id = sacrificeSubject, Duration = 2, Delay = 0.5, EaseIn = 0.05, EaseOut = 1 })
	local currentTutorialZoom = GetCameraZoom({ })
	FocusCamera({ Fraction = 0.9, Duration = 9.5, ZoomType = "Ease" })

	FadeInOutline( sacrificeSubject )

	wait(3.5)
	DisplayInfoPanelText({ Name = "Info_SacrificeScore", Duration = 5 })

	wait(6)
	FadeOutOutline( sacrificeSubject )

	FocusCamera({ Fraction = currentTutorialZoom, Duration = 1, ZoomType = "Ease" })

	wait(1)
	BeginRivalTeamIntroduction()
end

OnControlPressed{ "Jump",
	RequiredFlag = "JumpTutorial",
	function(triggerArgs)
		SetFlagFalse({ Name = "JumpTutorial" })
		DisableInput({ PlayerIndex = 1 })
		wait(1)
		thread(ShowInputDisabledPresentation)
		MarkObjectiveComplete("JumpTutorial")
		wait(0.65)
		jumpGoal = true
		local currentlyActiveTutorialUnit = GetActiveUnitId({ PlayerIndex = 1 })
		PanCamera({ Ids = { currentlyActiveTutorialUnit,  goalB }, EaseIn = 0.05, EaseOut = 0.2, Duration = 2 })
		DisplayObjective("JumpTutorialGoal")
		wait(0.3)
		EnableInput({ PlayerIndex = 1 })
		thread(HideInputDisabledPresentation)
	end
}

OnUsed{ "GoalB",
	RequiredFlag = "GoalsTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("GoalsTutorial")
	end
}

OnControlPressed{ "Throw",
	RequiredFlag = "ThrowTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("ThrowTutorial")
		wait(1.5)
	end
}

OnWeaponFired{
	RequiredWeapon = "CastSmall CastMedium CastLarge CastMediumAlt CastTrail CastImp CastFlying CastTree CastMonster",
	RequiredFlag = "AllowDisarmedHint",
	function(triggerArgs)
		local activeUnitDisarmed = GetActiveUnitId({ PlayerIndex = 1 })
		if not ballDisarmHint and activeUnitDisarmed == BallCarrierId then
			ballDisarmHint = true
			DisplayInfoPanelText({ Name = "Info_BallDisarmsWeapon", Duration = 3 })
		end
	end
}

-- Dynamic Teaching
OnAnyLoad
{
	function( triggerArgs )
		TalliedActions = {
			--["TalliedPasses"] = 0,
			["TalliedSprints"] = 0,
			["TalliedCasts"] = 0,
			["TalliedJumps"] = 0,
		}

		SetFlagFalse({ Name = "TallyPlayerActions" })
	end
}

OnControlPressed{ "Pass",
	PlayerIndex = 1,
	RequiredFlag = "TallyPlayerActions",
	function(triggerArgs)
		if TalliedActions["TalliedPasses"] ~= nil then
			TalliedActions["TalliedPasses"] = TalliedActions["TalliedPasses"] + 1
		end
	end
}

OnControlPressed{ "Cast",
	PlayerIndex = 1,
	RequiredFlag = "TallyPlayerActions",
	function(triggerArgs)
		if TalliedActions["TalliedCasts"] ~= nil then
			TalliedActions["TalliedCasts"] = TalliedActions["TalliedCasts"] + 1
		end
	end
}

OnControlPressed{ "Jump",
	PlayerIndex = 1,
	RequiredFlag = "TallyPlayerActions",
	function(triggerArgs)
		if TalliedActions["TalliedJumps"] ~= nil then
			TalliedActions["TalliedJumps"] = TalliedActions["TalliedJumps"] + 1
		end
	end
}

OnControlPressed{ "Sprint",
	PlayerIndex = 1,
	RequiredFlag = "TallyPlayerActions",
	function(triggerArgs)
		if TalliedActions["TalliedSprints"] ~= nil then
			TalliedActions["TalliedSprints"] = TalliedActions["TalliedSprints"] + 1
		end
	end
}

function CheckAdditionalTutorialObjectives()
	if introMatch then
		if additionalTutorialObjectiveActive then
			return false
		elseif TeamA.NumScores >= 3 then
			return true
		elseif TeamB.NumScores >= 1 then
			return true
		end
	end

	return false
end

function ProcessTalliedActions()
	local lowestAction = nil
	local lowestTally = 999999

	for action, tally in pairs(TalliedActions) do
		if tally <= lowestTally then
			lowestTally = tally
			lowestAction = action
		end
	end

	if lowestAction == nil then
		return
	end

	TalliedActions[lowestAction] = nil
	if lowestAction == "TalliedSprints" then
		additionalTutorialObjectiveActive = true
		DisplayObjective("SprintTutorial2")
	elseif lowestAction == "TalliedCasts" then
		additionalTutorialObjectiveActive = true
		DisplayObjective("CastTutorial2")
	elseif lowestAction == "TalliedJumps" then
		additionalTutorialObjectiveActive = true
		DisplayObjective("JumpTutorial2")
	end
end

function PreDraftTutorial()

	if practiceMatch or IsMultiplayerMatch() then
		return
	end

	-- Ti'zo tutorial
	if matchesPlayed == 2 and GetMapName({ }) == "MatchSiteD" then
		CommenceImpInstitute()
		waitUntil( "ImpTutorialComplete" )
		--PanCamera({ Id = ballId, Duration = 1.25, EaseOut = 0.3, OffsetX = 0 })
		--wait(1.0)
	end

	-- Bertrude tutorial
	if PlayerTeam.AscensionMatchesPlayed == 2 and MatchesPlayedThisSeason == 0 then
		CommenceCroneCollege()
		waitUntil( "CroneCollegeComplete" )
		--PanCamera({ Id = ballId, Duration = 1.25, EaseOut = 0.3, OffsetX = 0 })
		--wait(1.0)
	end

	-- Volfred tutorial
	if PlayerTeam.AscensionMatchesPlayed == 3 and MatchesPlayedThisSeason == 0 then
		CommenceTreeTutelage()
		waitUntil( "TreeTutelageComplete" )
		--PanCamera({ Id = ballId, Duration = 1.25, EaseOut = 0.3, OffsetX = 0 })
		--wait(1.0)
	end

end

function CommenceImpInstitute()

	AddInputBlock({ Name = "ImpInstituteTutorial" })

	AssignCharacter( CharMascot, PositionIds.LeftMiddleId )
	SwitchActiveUnit({ Id  = CharMascot.ObjectId, PlayerIndex = 1 })
	SetMenuOptions({ Name = "InGameUI", Properties = { Run = "SetupMatchCharacters" } })
	impUnit = CharMascot.ObjectId
	impInstitute = true
	SetOpacity({ Id = impUnit, Fraction = 0 })

	UseableOff({ Id = ballId })
	SetInvulnerable({ Ids = TeamB.ObjectIds })
	thread(ShowInputDisabledPresentation)

	ToggleControl({ Names = { "Pass", "Cast", "Jump", "Sprint" }, Enabled = false })
	SetConfigOption({ Name = "PlayerTwoAI", Value = false })

	impInstituteLockPoint = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = GetActiveUnitId({ PlayerIndex = 1 }), Group = "Scripting" })
	PanCamera({ Id = impInstituteLockPoint, Duration = 2.0, EaseOut = 0.5 })
	FocusCamera({ Fraction = 0.5, Duration = 2.0, ZoomType = "Ease" })

	PlaySound({ Name = "/Music/Stingers/ShortSting6", Delay = 0.9 })
	SpecialMatchIntroEntrances( "Tizo", impUnit, 1, nil, "UseDraftVFX" )

	wait(1.0)
	PlayMatchDialogue( "tutorialstart" )
	wait(1.0)
	thread( PlayMatchSpeech, "week3_tizotutorial" )
	thread(HideInputDisabledPresentation)
	RemoveInputBlock({ Name = "ImpInstituteTutorial" })
	EnableInput({ PlayerIndex = 1 })
	CreateCameraWalls({ OffsetX = 100, OffsetY = 200 })

	ShowControlUI()
	TeachImpFlutter()
end

function TeachImpFlutter()
	ToggleControl({ Names = { "Jump" }, Enabled = true })
	DisplayObjective("ImpJump")
end

--[[}
OnWeaponFired{ "JumpImp",
	PlayerIndex = 1,
	RequiredFlag = "ImpJumpTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("ImpJump")
		wait(0.2)
		TeachImpSprint()

	end
}
]]

OnStaminaEmpty{
	RequiredFlag = "ImpJumpTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("ImpJump")
		wait(0.2)
		TeachImpSprint()
	end
}

function TeachImpSprint()
	ToggleControl({ Names = { "Sprint" }, Enabled = true })
	DisplayObjective("ImpSprint")
end

impSprints = 0
OnWeaponFired{ "SprintImp",
	PlayerIndex = 1,
	RequiredFlag = "ImpSprintTutorial",
	function(triggerArgs)
		impSprints = impSprints + 1
		UpdateObjectiveProgress("ImpSprint")
		wait(0.2)
		if impSprints >= 7 then
			TeachImpCast()
		end
	end
}

function TeachImpCast()
	ToggleControl({ Names = { "Cast" }, Enabled = true })
	DisplayObjective("ImpCast")
end

OnWeaponFired{ "CastImp",
	PlayerIndex = 1,
	RequiredFlag = "ImpCastTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("ImpCast")
		wait(0.2)
		DisplayInfoPanelText({ Name = "Info_ImpCastRespawn", Duration = 2.75 })
		SwitchActiveUnit({ Id = impUnit, PlayerIndex = 1, Delay = 3.0 })
		wait(3.5)
		TeachImpTaunt()
	end
}

function TeachImpTaunt()
	ShowControlUI()
	DisplayObjective("ImpTaunt")
end

OnControlPressed{ "Taunt",
	PlayerIndex = 1,
	RequiredFlag = "ImpTauntTutorial",
	function(triggerArgs)
		if not IsAlive({ Id = impUnit }) then
			PlaySound({ Name = "/SFX/Match SFX/OutOfAmmo2" })
			return
		end

		MarkObjectiveComplete("ImpTaunt")

		wait(0.6)
		--NarrationSequence( "Week3_Match_ImpTutorialEnd" )

		local character = GetCharacterTableByObjectId(impUnit)
		PlayAnimation({ Name = "PlayerImpEntrance2", DestinationId = impUnit })
		SetOpacity({ Id = impUnit, Fraction = 0, Duration = 0.3, Delay = 0.1 })
		PlayOverheadAnimation({ Name = "DraftChoose", DestinationId = impUnit, IgnoreOverheadOffset = true, Scale = DraftFXScale[character.Archetype] })
		ToggleControl({ Names = { "Pass", "Cast", "Sprint", "Jump" }, Enabled = true })
		fancyCamera = true
		MatchCameraSelector()
		DestroyCameraWalls({  })
		UseableOn({ Id = ballId })

		DisableInput({ })
		HideMatchUI()

		PanCamera({ Id = ballId, Duration = 1.0 })

		wait(1.0) -- Let the MatchUI fadeout before unassigning the Imp
		Teleport({ Id = impUnit, DestinationId = StartingPositions[impUnit] })
		CharMascot.ActiveStatus = "None"
		impInstitute = false
		SetVulnerable({ Ids = TeamB.ObjectIds })
		if ResetRockStartPoints ~= nil then
			--thread( ResetRockStartPoints )
		end
		notifyExistingWaiters( "ImpTutorialComplete" )
	end
}


-- PlayerFlying / Pamitha Tutorial

function CommenceFlightSchool()

	AddInputBlock({ Name = "FlightSchoolTutorial" })
	ToggleControl({ Names = { "Pass", "Cast", "Jump", "Sprint" }, Enabled = false })
	SetConfigOption({ Name = "PlayerTwoAI", Value = false })
	SwitchActiveUnit({ Id  = CharVamp.ObjectId, PlayerIndex = 1 })
	flightSchool = true
	UseableOff({ Id = ballId })
	SetOpacity({ Id = ballId, Fraction = 0, Duration = 0.3 })
	thread(ShowInputDisabledPresentation)

	wait(0.8)
	NarrationSequence( "Week6_Match_FlyingTutorialStart" )
	wait(0.1)
	thread( PlayMatchSpeech, "week6_pamithatutorial" )

	TeachFlyingJump()

	flightSchoolLockPoint = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = GetActiveUnitId({ PlayerIndex = 1 }), Group = "Scripting" })
	local currentMatchZoom = GetCameraZoom({ })
	FocusCamera({ Fraction = 0.5, Duration = 0.5 })
	PanCamera({ Id = flightSchoolLockPoint, Duration = 1, OffsetX = 220 })
	wait(1.0)
	CreateCameraWalls({ OffsetX = 100, OffsetY = 50 })
	RemoveInputBlock({ Name = "FlightSchoolTutorial" })
	EnableInput({ PlayerIndex = 1 })

	SetMenuOptions({ Name = "InGameUI", Properties = { Run = "SetupMatchCharacters" } })
	ShowControlUI()
	thread(HideInputDisabledPresentation)
end

function TeachFlyingJump()
	ToggleControl({ Names = { "Jump" }, Enabled = true })
	DisplayObjective("FlyingJump")
end

--[[
OnWeaponFired{ "JumpFlying",
	PlayerIndex = 1,
	RequiredFlag = "FlyingJumpTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("FlyingJump")
		wait(0.2)
		TeachFlyingSprint()
	end
}
]]

OnStaminaEmpty{
	RequiredFlag = "FlyingJumpTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("FlyingJump")
		wait(0.2)
		TeachFlyingSprint()
	end
}

function TeachFlyingSprint()
	ToggleControl({ Names = { "Sprint" }, Enabled = true })
	DisplayObjective("FlyingSprint")
end

flyingSprints = 0
OnWeaponFired{ "SprintFlying",
	PlayerIndex = 1,
	RequiredFlag = "FlyingSprintTutorial",
	function(triggerArgs)
		flyingSprints = flyingSprints + 1
		UpdateObjectiveProgress("FlyingSprint")

		if flyingSprints == 2 then
			DisplayInfoPanelText({ Name = "Info_FlyingDash", Duration = 2.9 })
		end

		wait(0.2)
		if flyingSprints >= 4 then
			TeachFlyingWeapon()
		end
	end
}

function TeachFlyingWeapon()
	ToggleControl({ Names = { "Cast" }, Enabled = true })
	DisplayObjective("FlyingWeapon")
end

flyingCasts = 0
OnWeaponFired{ "CastFlying",
	PlayerIndex = 1,
	RequiredFlag = "FlyingWeaponTutorial",
	function(triggerArgs)
		flyingCasts = flyingCasts + 1
		UpdateObjectiveProgress("FlyingWeapon")

		if flyingCasts == 1 then
			DisplayInfoPanelText({ Name = "Info_FlyingInvulnerable" })
		end

		if flyingCasts >= 3 then
			AddInputBlock({ Name = "FlightSchoolComplete" })
			SetFlagFalse({ Name = "FlyingWeaponTutorial" })
			wait(1.5)
			NarrationSequence( "Week6_Match_FlyingTutorialEnd" )

			ToggleControl({ Names = { "Pass", "Cast", "Sprint", "Jump" }, Enabled = true })
			fancyCamera = true
			MatchCameraSelector()
			DestroyCameraWalls({  })

			flightSchool = false
			FadeOut({ Color = Color.Black, Duration = 0.35 })
			wait(0.36)
			TeleportToExactStartPositions()
			SetGoalAngle({ Id = CharVamp.ObjectId, Angle = 0 })
			PanCamera({ Id = ballId, Duration = 0.35 })
			hideEntireUI()
			ShowInputDisabledPresentation()
			wait(0.14)
			FadeIn({ Duration = 0.35 })
			wait(0.5)
			RemoveInputBlock({ Name = "FlightSchoolComplete" })
			UseableOn({ Id = ballId })
			StartMatch()
		end
	end
}

-- Crone College

function CommenceCroneCollege()

	FireTrigger({ Name = "EndCurrentMusic" })
	-- thread( CharacterMusic, nil, CharDiva )

	AddInputBlock({ Name = "CroneCollegeTutorial" })

	AssignCharacter( CharDiva, PositionIds.LeftMiddleId )
	SwitchActiveUnit({ Id  = CharDiva.ObjectId, PlayerIndex = 1 })
	SetMenuOptions({ Name = "InGameUI", Properties = { Run = "SetupMatchCharacters" } })
	croneUnit = CharDiva.ObjectId
	croneCollege = true
	SetOpacity({ Id = croneUnit, Fraction = 0 })

	UseableOff({ Id = ballId })
	SetInvulnerable({ Ids = TeamB.ObjectIds })
	thread(ShowInputDisabledPresentation)

	ToggleControl({ Names = { "Pass", "Cast", "Jump", "Sprint" }, Enabled = false })
	SetConfigOption({ Name = "PlayerTwoAI", Value = false })

	croneCollegeLockPoint = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = GetActiveUnitId({ PlayerIndex = 1 }), Group = "Scripting" })
	PanCamera({ Id = croneCollegeLockPoint, Duration = 2.0, EaseOut = 0.5 })
	FocusCamera({ Fraction = 0.5, Duration = 2.0, ZoomType = "Ease" })

	PlaySound({ Name = "/SFX/Match SFX/PlayerRespawnNEW", Delay = 0.9 })
	SpecialMatchIntroEntrances( "Bertrude", croneUnit, 1, nil, "UseDraftVFX" )

	wait(1.0)
	PlayMatchDialogue( "tutorialstart" )
	wait(1.0)
	thread( PlayMatchSpeech, "bertrudetutorial" )
	thread(HideInputDisabledPresentation)
	RemoveInputBlock({ Name = "CroneCollegeTutorial" })
	EnableInput({ PlayerIndex = 1 })
	CreateCameraWalls({ OffsetX = 100, OffsetY = 200 })

	ShowControlUI()
	TeachMonsterJump()
end

function TeachMonsterJump()
	ToggleControl({ Names = { "Jump" }, Enabled = true })
	DisplayObjective("MonsterJump")
end

monsterJumps = 0
OnWeaponFired{ "JumpMonster",
	PlayerIndex = 1,
	RequiredFlag = "MonsterJumpTutorial",
	function(triggerArgs)
		monsterJumps = monsterJumps + 1
		UpdateObjectiveProgress("MonsterJump")

		if monsterJumps == 1 then
			--DisplayInfoPanelText({ Name = "Info_MonsterJump", Delay = 1.5, Duration = 2.9 })
		end

		wait(0.2)
		if monsterJumps >= 3 then
			TeachMonsterSprint()
		end
	end
}

function TeachMonsterSprint()
	ToggleControl({ Names = { "Sprint" }, Enabled = true })
	DisplayObjective("MonsterSprint")
end

OnWeaponFired{ "SprintMonster",
	PlayerIndex = 1,
	RequiredFlag = "MonsterSprintTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("MonsterSprint")
		wait(0.2)
		TeachMonsterCast()
	end
}

function TeachMonsterCast()
	ToggleControl({ Names = { "Cast" }, Enabled = true })
	DisplayObjective("MonsterCast")
end

monsterCasts = 0
OnWeaponFired{ "CastMonster",
	PlayerIndex = 1,
	RequiredFlag = "MonsterCastTutorial",
	function(triggerArgs)
		monsterCasts = monsterCasts + 1
		UpdateObjectiveProgress("MonsterCast")
		wait(1.0)
		if monsterCasts >= 3 then
			DisplayObjective("MonsterPowerCast")
		end
	end
}

OnWeaponFired{ "CastMonster",
	PlayerIndex = 1,
	RequiredFlag = "MonsterPowerCastTutorial",
	function(triggerArgs)
		if triggerArgs.IsPerfectCharge or timesPowerCastFailed == 3 then
			MarkObjectiveComplete("MonsterPowerCast")
			wait(1.0)
			DisplayObjective("MonsterTaunt")
		else
			if timesPowerCastFailed == nil then
				timesPowerCastFailed = 1
			else
				timesPowerCastFailed = timesPowerCastFailed + 1
			end
		end
	end
}

OnControlPressed{ "Taunt",
	PlayerIndex = 1,
	RequiredFlag = "MonsterTauntTutorial",
	function(triggerArgs)
		GraduateCroneCollege()
	end
}

function GraduateCroneCollege()
	MarkObjectiveComplete( "MonsterTaunt" )
	wait(0.6)
	PlayMatchDialogue( "tutorialend" )

	local character = GetCharacterTableByObjectId(croneUnit)
	PlayAnimation({ Name = "PlayerMonsterJump", DestinationId = croneUnit })
	PlayOverheadAnimation({ Name = "DraftChoose", DestinationId = croneUnit, IgnoreOverheadOffset = true, Scale = DraftFXScale[character.Archetype] })
	SetOpacity({ Id = croneUnit, Fraction = 0, Duration = 0.3, Delay = 0.1 })
	ToggleControl({ Names = { "Pass", "Cast", "Sprint", "Jump" }, Enabled = true })
	fancyCamera = true
	--MatchCameraSelector()
	DestroyCameraWalls({  })
	UseableOn({ Id = ballId })

	PanCamera({ Id = ballId, Duration = 1.0 })

	DisableInput({ })
	HideMatchUI()
	wait(1.0) -- Let the MatchUI fadeout before unassigning the Crone
	Teleport({ Id = croneUnit, DestinationId = StartingPositions[croneUnit] })
	AngleTowardTarget({ Id = croneUnit, DestinationId = TeamB.PyreId })
	CharDiva.ActiveStatus = "None"
	croneCollege = false
	SetVulnerable({ Ids = TeamB.ObjectIds })
	if ResetRockStartPoints ~= nil then
		thread( ResetRockStartPoints )
	end
	notifyExistingWaiters( "CroneCollegeComplete" )
end

-- Tree Tutelage
function CommenceTreeTutelage()

	FireTrigger({ Name = "EndCurrentMusic" })
	-- thread( CharacterMusic, nil, CharDoc )

	AddInputBlock({ Name = "TreeTutelageTutorial" })

	AssignCharacter( CharDoc, PositionIds.LeftMiddleId )
	SwitchActiveUnit({ Id  = CharDoc.ObjectId, PlayerIndex = 1 })
	SetMenuOptions({ Name = "InGameUI", Properties = { Run = "SetupMatchCharacters" } })
	treeUnit = CharDoc.ObjectId
	treeTutelage = true
	SetOpacity({ Id = treeUnit, Fraction = 0 })

	UseableOff({ Id = ballId })
	SetInvulnerable({ Ids = TeamB.ObjectIds })
	thread(ShowInputDisabledPresentation)

	ToggleControl({ Names = { "Pass", "Cast", "Jump", "Sprint" }, Enabled = false })
	SetConfigOption({ Name = "PlayerTwoAI", Value = false })

	treeTutelageLockPoint = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = GetActiveUnitId({ PlayerIndex = 1 }), Group = "Scripting" })
	PanCamera({ Id = treeTutelageLockPoint, Duration = 2.0, EaseOut = 0.5 })
	FocusCamera({ Fraction = 0.5, Duration = 2.0, ZoomType = "Ease" })

	PlaySound({ Name = "/SFX/Match SFX/PlayerRespawnNEW", Delay = 0.9 })
	SpecialMatchIntroEntrances( "Volfred", treeUnit, 1, nil, "UseDraftVFX" )

	wait(1.0)
	PlayMatchDialogue( "tutorialstart" )
	wait(1.0)
	thread( PlayMatchSpeech, "volfredtutorial" )
	thread(HideInputDisabledPresentation)
	RemoveInputBlock({ Name = "TreeTutelageTutorial" })
	EnableInput({ PlayerIndex = 1 })
	CreateCameraWalls({ OffsetX = 100, OffsetY = 200, DeepWalls = true })

	ShowControlUI()
	TeachTreeJump()
end

function TeachTreeJump()
	ToggleControl({ Names = { "Jump" }, Enabled = true })
	DisplayObjective("TreeJump")
end

treeShields = 0
OnFreshWeaponFire{ "JumpTree",
	PlayerIndex = 1,
	RequiredFlag = "TreeJumpTutorial",
	function(triggerArgs)
		treeShields = treeShields + 1
		UpdateObjectiveProgress("TreeJump")

		if treeShields == 1 then
			DisplayInfoPanelText({ Name = "Info_TreeShield", Delay = 1.5, Duration = 3.3 })
		end

		wait(0.2)
		if treeShields >= 3 then
			TeachTreeSprint()
		end
	end
}

function TeachTreeSprint()
	ToggleControl({ Names = { "Sprint" }, Enabled = true })
	DisplayObjective("TreeSprint")
end

treeSprints = 0
OnWeaponFired{ "SprintTree",
	PlayerIndex = 1,
	RequiredFlag = "TreeSprintTutorial",
	function(triggerArgs)
		treeSprints = treeSprints + 1
		UpdateObjectiveProgress("TreeSprint")
		wait(0.2)
		if treeSprints >= 4 then
			TeachTreeCast()
		end
	end
}

function TeachTreeCast()
	ToggleControl({ Names = { "Cast" }, Enabled = true })
	DisplayObjective("TreeCast")
end

treeCasts = 0
OnWeaponFired{ "CastTree",
	PlayerIndex = 1,
	RequiredFlag = "TreeCastTutorial",
	function(triggerArgs)
		treeCasts = treeCasts + 1
		UpdateObjectiveProgress("TreeCast")

		if treeCasts == 1 then
			DisplayInfoPanelText({ Name = "Info_TreeCast", Duration = 3.3, Delay = 1.3 })
		end

		wait(1.0)
		if treeCasts >= 3 then
			DisplayObjective("TreeTaunt")
		end
	end
}

OnControlPressed{ "Taunt",
	PlayerIndex = 1,
	RequiredFlag = "TreeTauntTutorial",
	function(triggerArgs)
		MarkObjectiveComplete("TreeTaunt")

		wait(0.6)
		PlayMatchDialogue( "tutorialend" )

		local character = GetCharacterTableByObjectId(treeUnit)
		PlayAnimation({ Name = "PlayerTreeWormholeCharging", DestinationId = treeUnit })
		PlayOverheadAnimation({ Name = "DraftChoose", DestinationId = treeUnit, IgnoreOverheadOffset = true, Scale = DraftFXScale[character.Archetype] })
		SetOpacity({ Id = treeUnit, Fraction = 0, Duration = 0.3, Delay = 0.1 })
		ToggleControl({ Names = { "Pass", "Cast", "Sprint", "Jump" }, Enabled = true })
		fancyCamera = true
		--MatchCameraSelector()
		DestroyCameraWalls({  })
		UseableOn({ Id = ballId })

		PanCamera({ Id = ballId, Duration = 1.0 })

		DisableInput({ })
		HideMatchUI()
		wait(1.0) -- Let the MatchUI fadeout before unassigning the Tree
		Teleport({ Id = treeUnit, DestinationId = StartingPositions[treeUnit] })
		AngleTowardTarget({ Id = treeUnit, DestinationId = TeamB.PyreId })
		CharDoc.ActiveStatus = "None"
		treeTutelage = false
		SetVulnerable({ Ids = TeamB.ObjectIds })
		if ResetRockStartPoints ~= nil then
			thread( ResetRockStartPoints )
		end
		ClearDefenders()
		notifyExistingWaiters( "TreeTutelageComplete" )
	end
}