--[[ **PLAYER SKILL SCRIPTS** ]]

Import "UtilityScripts.lua"
Import "Color.lua"
Import "LeagueUtilityScripts.lua"

PlayerSkillsTable =
{
	-- Player Large Skills
	-- TREE A
	["DoubleRush"] =
	{
		Tree = "PlayerLargeA",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint",
	},

	["EvadeStun"] =
	{
		Tree = "PlayerLargeA",
		Tier = 2,
		Prerequisites = { "DoubleRush" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},

	["TauntScoreSkill10"] =
	{
		Tree = "PlayerLargeA",
		Tier = 2,
		Prerequisites = { "DoubleRush" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt",
	},

	["AuraSpikeKill"] =
	{
		Tree = "PlayerLargeA",
		Tier = 3,
		Prerequisites = { "TauntScoreSkill10", "EvadeStun" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_ball_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_ball_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_ball",
	},


	-- TREE B
	["KillsRegenerateStamina100"] =
	{
		Tree = "PlayerLargeB",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina",
	},

	["PlusPresenceSkill"] =
	{
		Tree = "PlayerLargeB",
		Tier = 2,
		Prerequisites = { "KillsRegenerateStamina100" },
		GiveTrait = "PlusAura04",
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_aura_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura",
	},

	["PyreHealthSkill35"] =
	{
		Tree = "PlayerLargeB",
		Tier = 2,
		Side = "Right",
		Prerequisites = { "KillsRegenerateStamina100" },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth",
	},

	["PlusEnemyRespawnTime"] =
	{
		Tree = "PlayerLargeB",
		Tier = 3,
		Prerequisites = { "PlusPresenceSkill", "PyreHealthSkill35" },
		PlayerUnitUpgrade = true,
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},





	-- PlayerSmall
	-- TREE A
	["DoubleJump"] =
	{
		Tree = "PlayerSmallA",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},
	["SprintSpeed"] =
	{
		Tree = "PlayerSmallA",
		Tier = 2,
		Prerequisites = { "DoubleJump" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint",
	},
	["InstantRespawn"] =
	{
		Tree = "PlayerSmallA",
		Tier = 2,
		Side = "Right",
		Prerequisites = { "DoubleJump" },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},
	["TripleJump"] =
	{
		Tree = "PlayerSmallA",
		Tier = 3,
		Prerequisites = { "SprintSpeed", "InstantRespawn" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},

	-- TREE B
	["SacrificeScoreSkill5"] =
	{
		Tree = "PlayerSmallB",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage",
	},
	["UnlimitedRange"] =
	{
		Tree = "PlayerSmallB",
		Tier = 2,
		Prerequisites = { "SacrificeScoreSkill5" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},
	["AuraKillDetonate100"] =
	{
		Tree = "PlayerSmallB",
		Tier = 2,
		Prerequisites = { "SacrificeScoreSkill5" },
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},
	["SacrificeScoreRespawn100"] =
	{
		Tree = "PlayerSmallB",
		Tier = 3,
		Prerequisites = { "UnlimitedRange", "AuraKillDetonate100" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},


	-- PlayerMedium
	-- TREE A
	["StaminaSkill"] =
	{
		Tree = "PlayerMediumA",
		Tier = 1,
		Prerequisites = { },
		GiveTrait = "PlusStamina05",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_speed_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed",
	},

	["MassivePowerShot"] =
	{
		Tree = "PlayerMediumA",
		Tier = 2,
		Prerequisites = { "StaminaSkill" },
		PlayerUnitUpgrade = true,
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},

	["JumpKillSkill"] =
	{
		Tree = "PlayerMediumA",
		Tier = 2,
		Prerequisites = { "StaminaSkill" },
		PlayerUnitUpgrade = true,
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},

	["GoalLifeStealSkill50"] =
	{
		Tree = "PlayerMediumA",
		Tier = 3,
		Prerequisites = { "MassivePowerShot", "JumpKillSkill" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth",
	},

	-- TREE B
	["TeamStaminaRechargeSkill"] =
	{
		Tree = "PlayerMediumB",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina",
	},

	["TeamBallSkill"] =
	{
		Tree = "PlayerMediumB",
		Tier = 2,
		Prerequisites = { "TeamStaminaRechargeSkill" },
		PlayerUnitUpgrade = true,
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_ball_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_ball_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_ball",
	},

	["TeamReviveSkill"] =
	{
		Tree = "PlayerMediumB",
		Tier = 2,
		Prerequisites = { "TeamStaminaRechargeSkill" },
		PlayerUnitUpgrade = true,
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},

	["TeamEnemyBanishTime"] =
	{
		Tree = "PlayerMediumB",
		Tier = 3,
		Prerequisites = { "TeamBallSkill", "TeamReviveSkill" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},


	-- PlayerMediumAlt
	-- TREE A

	["MobilityChargeTime"] =
	{
		Tree = "PlayerMediumAltA",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_speed_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed",
	},

	["JumpDistance"] =
	{
		Tree = "PlayerMediumAltA",
		Tier = 2,
		Prerequisites = { "MobilityChargeTime" },
		PlayerUnitUpgrade = true,
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},

	["SprintAreaSlow"] =
	{
		Tree = "PlayerMediumAltA",
		Tier = 2,
		Prerequisites = { "MobilityChargeTime" },
		PlayerUnitUpgrade = true,
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint",
	},

	["JumpRespawn"] =
	{
		Tree = "PlayerMediumAltA",
		Tier = 3,
		Prerequisites = { "JumpDistance", "SprintAreaSlow" },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},


	-- TREE B

	["CastChargeTime"] =
	{
		Tree = "PlayerMediumAltB",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},

	["TossSkillMediumAlt"] =
	{
		Tree = "PlayerMediumAltB",
		Tier = 2,
		Prerequisites = { "CastChargeTime" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_ball_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_ball_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_ball",
	},

	["TauntBallTeleport"] =
	{
		Tree = "PlayerMediumAltB",
		Tier = 2,
		Prerequisites = { "CastChargeTime" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt",
	},

	["UnlimitedBallStamina"] =
	{
		Tree = "PlayerMediumAltB",
		Tier = 3,
		Prerequisites = { "TossSkillMediumAlt", "TauntBallTeleport" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},

	-- PlayerImp
	-- TREE A
	["MoveBetter"] =
	{
		Tree = "PlayerImpA",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_speed_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed",
	},

	["CastFastRespawn"] =
	{
		Tree = "PlayerImpA",
		Tier = 2,
		Prerequisites = { "MoveBetter" },
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},

	["ExplodeBigger"] =
	{
		Tree = "PlayerImpA",
		Tier = 2,
		Prerequisites = { "MoveBetter" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},

	["AnyScoreSkill"] =
	{
		Tree = "PlayerImpA",
		Tier = 3,
		Prerequisites = { "CastFastRespawn", "ExplodeBigger" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage",
	},

	-- TREE B
	["Beacon"] =
	{
		Tree = "PlayerImpB",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},

	["OnDeathExplosion"] =
	{
		Tree = "PlayerImpB",
		Tier = 2,
		Prerequisites = { "Beacon" },
		PlayerUnitUpgrade = true,
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_aura_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura",
	},

	["TauntFeralImp"] =
	{
		Tree = "PlayerImpB",
		Tier = 2,
		Prerequisites = { "Beacon" },
		PlayerUnitUpgrade = true,
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt",
	},

	["BetterBeacon"] =
	{
		Tree = "PlayerImpB",
		Tier = 3,
		Prerequisites = { "OnDeathExplosion", "TauntFeralImp" },
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_05_on",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},


	-- PlayerTrail
	-- TREE A
	["AllDeadRespawn"] =
	{
		Tree = "PlayerTrailA",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},
	["TauntTimeout"] =
	{
		Tree = "PlayerTrailA",
		Tier = 1,
		Prerequisites = { "AllDeadRespawn" },
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt",
	},
	["SoleUnitPowerUp"] =
	{
		Tree = "PlayerTrailA",
		Tier = 2,
		Prerequisites = { "AllDeadRespawn" },
		Side = "Right",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_speed_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed",
	},
	["BanishScoreBonus"] =
	{
		Tree = "PlayerTrailA",
		Tier = 3,
		Prerequisites = { "TauntTimeout", "SoleUnitPowerUp" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage",
	},

	-- TREE B

	["KillsRespawnFriends100"] =
	{
		Tree = "PlayerTrailB",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_aura_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura",
	},
	["WeaponReTeleport"] =
	{
		Tree = "PlayerTrailB",
		Tier = 2,
		Prerequisites = { "KillsRespawnFriends100" },
		Side = "Left",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},
	["TrailExplosion"] =
	{
		Tree = "PlayerTrailB",
		Tier = 2,
		Side = "Right",
		Prerequisites = { "KillsRespawnFriends100" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},
	["WeaponRechargeStamina"] =
	{
		Tree = "PlayerTrailB",
		Tier = 3,
		Prerequisites = { "WeaponReTeleport", "TrailExplosion" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina",
	},

	-- PlayerFlying
	-- TREE A
	["AirSpeed"] =
	{
		Tree = "PlayerFlyingA",
		Tier = 1,
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},
	["DashCooldown"] =
	{
		Tree = "PlayerFlyingA",
		Tier = 2,
		Side = "Left",
		Prerequisites = { "AirSpeed" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_sprint_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_sprint",
	},
	["TauntSwap"] =
	{
		Tree = "PlayerFlyingA",
		Tier = 2,
		Prerequisites = { "AirSpeed" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt",
	},
	["PlusSpeedSkill"] =
	{
		Tree = "PlayerFlyingA",
		Tier = 3,
		Prerequisites = { "DashCooldown", "TauntSwap" },
		GiveTrait = "PlusSpeed08",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_speed_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed",
	},

	-- TREE B
	["OnKillBuffSpeed"] =
	{
		Tree = "PlayerFlyingB",
		Tier = 1,
		Prerequisites = { },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},
	["CastExplosion"] =
	{
		Tree = "PlayerFlyingB",
		Tier = 2,
		Prerequisites = { "OnKillBuffSpeed" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},
	["RespawnBuff"] =
	{
		Tree = "PlayerFlyingB",
		Tier = 2,
		Prerequisites = { "OnKillBuffSpeed" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},
	["PlusStatsSkill"] =
	{
		Tree = "PlayerFlyingB",
		Tier = 3,
		Prerequisites = { "CastExplosion", "RespawnBuff" },
		GiveTrait = "PlusStats04",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},

	-- PlayerTree
	-- TREE A
	["SpawnDefenderUnit"] =
	{
		Tree = "PlayerTreeA",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},
	["DefenderAura"] =
	{
		Tree = "PlayerTreeA",
		Tier = 2,
		Prerequisites = { "SpawnDefenderUnit" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_aura_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura",
	},
	["TauntSaplingExplode"] =
	{
		Tree = "PlayerTreeA",
		Tier = 2,
		Prerequisites = { "SpawnDefenderUnit" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},
	["TeamHeadWinds"] =
	{
		Tree = "PlayerTreeA",
		Tier = 3,
		Prerequisites = { "DefenderAura", "TauntSaplingExplode" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_banishment_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_banishment",
	},

	-- TREE B
	["PyreLastHitShield10"] =
	{
		Tree = "PlayerTreeB",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth",
	},
	["ShieldAllies"] =
	{
		Tree = "PlayerTreeB",
		Tier = 2,
		Prerequisites = { "PyreLastHitShield10" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_evade_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_evade",
	},
	["PlusHopeSkill"] =
	{
		Tree = "PlayerTreeB",
		Tier = 2,
		Prerequisites = { "PyreLastHitShield10" },
		Side = "Right",
		GiveTrait = "PlusAttitude05",
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_respawn_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_respawn",
	},
	["PyreLastHitShield40"] =
	{
		Tree = "PlayerTreeB",
		Tier = 3,
		Prerequisites = { "ShieldAllies", "PlusHopeSkill" },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyrehealth",
	},

	-- PlayerMonster
	-- TREE A
	["LosingScoreSkill5"] =
	{
		Tree = "PlayerMonsterA",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage",
	},
	["CastMonsterSkill"] =
	{
		Tree = "PlayerMonsterA",
		Tier = 2,
		Prerequisites = { "LosingScoreSkill5" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_cast_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_cast",
	},
	["ChargeMonsterSkill"] =
	{
		Tree = "PlayerMonsterA",
		Tier = 2,
		Prerequisites = { "LosingScoreSkill5" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_aura_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_aura",
	},
	["LosingScoreScoreDebuff"] =
	{
		Tree = "PlayerMonsterA",
		Tier = 3,
		Prerequisites = { "CastMonsterSkill", "ChargeMonsterSkill" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_special_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_special_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_special",
	},

	-- TREE B
	["WinningScoreSkill5"] =
	{
		Tree = "PlayerMonsterB",
		Tier = 1,
		Prerequisites = { },
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_pyredamage",
	},
	["MonsterJumpSkill"] =
	{
		Tree = "PlayerMonsterB",
		Tier = 2,
		Prerequisites = { "WinningScoreSkill5" },
		Side = "Left",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_stamina_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_stamina",
	},
	["MonsterSprintSkill"] =
	{
		Tree = "PlayerMonsterB",
		Tier = 2,
		Prerequisites = { "WinningScoreSkill5" },
		Side = "Right",
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_speed_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_speed",
	},
	["TauntPolymorphSide"] =
	{
		Tree = "PlayerMonsterB",
		Tier = 3,
		Prerequisites = { "MonsterJumpSkill", "MonsterSprintSkill" },
		PlayerUnitUpgrade = true,
		UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_locked",
		AvailableIcon = "GUI\\Icons\\Skills\\skill_icon_taunt_available",
		PickedIcon = "GUI\\Icons\\Skills\\skill_icon_taunt",
	},

	-- special skills
	["SpreadWeaponSkill"] =
	{
		Tree = "SpecialSkills",
		Tier = 0,
		Prerequisites = {  },
		PlayerUnitUpgrade = true,
	},

	["UniqueMonsterSkill"] =
	{
		Tree = "SpecialSkills",
		Tier = 0,
		Prerequisites = {  },
		PlayerUnitUpgrade = true,
	},
}

OnAnyLoad
{
	function( triggerArgs )

		for skillName, skillData in pairs( PlayerSkillsTable ) do
			skillData.Name = skillName
			if skillData.UnpickedIcon == nil then
				skillData.UnpickedIcon = "GUI\\Icons\\Skills\\skill_icon_07_off"
			end
			if skillData.PickedIcon == nil then
				skillData.PickedIcon = "GUI\\Icons\\Skills\\skill_icon_07_on"
			end
		end

		if ConstellationStars == nil then
			ConstellationStars = DeepCopyTable( ConstellationStarData )
		end
		PersistVariable({ Name = "ConstellationStars" })

		TitanStarGroups = GetGroupWithSubGroups({ Name = "DifficultyStarArt" })

	end
}

function GetSkillsInTree( skillTree )
	local skills = { }
	for skillName, skillData in pairs( PlayerSkillsTable ) do
		if skillData.Tree == skillTree then
			table.insert( skills, skillName )
		end
	end
	return skills
end

function CanPickSkill( character, skillData )

	local numPrereqsMet = 0

	if character.SkillPoints <= 0 then
		return false
	end

	if HasSkillNotFromItem( character, skillData.Name ) then
		return false
	end

	if IsEmpty( skillData.Prerequisites ) then
		return true
	end

	for k, prereqs in pairs( skillData.Prerequisites ) do
		if HasSkillNotFromItem( character, prereqs ) and skillData.Tier < 3 then
			return true
		elseif HasSkillNotFromItem( character, prereqs ) and skillData.Tier == 3 then
			numPrereqsMet = numPrereqsMet + 1
		end

		if skillData.Tier == 3 and numPrereqsMet == 1 then
			return true
		end
	end

	return false

end

function HasSkillNotFromItem( character, skillName )

	if character == nil then
		return false
	end

	local itemSkill = nil
	if character.UpgradeItem ~= nil then
		itemSkill = GetFullSkillName( character.UpgradeItem )
	end

	local foundItemSkill = false
	for k, currentSkill in pairs( character.Skills ) do
		if not foundItemSkill and currentSkill == itemSkill then
			foundItemSkill = true
		elseif currentSkill == skillName then
			return true
		end
	end

	return false
end

function UnitHasSkill( char, skillName )
	return char.SkillLookup[skillName]
end

function GetUnitSkillValue( char, skillName )

	local value = char.SkillValues[skillName]
	if value == nil then
		return 0
	end

	return value

end

function CheckUnitSkillChance( char, skillName )

	local unitSkillValue = GetUnitSkillValue( char, skillName )
	if unitSkillValue <= 0 then
		return false
	end
	if RandomChance( unitSkillValue / 100 ) then
		return true
	end
	return false

end

function TeamHasSkill( team, skillName )
	for k, characterData in pairs( team.TeamBench ) do
		if UnitHasSkill( characterData, skillName ) then
			return true
		end
	end
	return false
end

function TeamHasSkillDrafted( team, skillName )
	return team.TeamSkills[skillName]
end

function GetCharacterWithSkill( team, skillName )
	for k, character in pairs( team.AssignedCharacters ) do
		if UnitHasSkill( character, skillName ) then
			return character
		end
	end
	return false
end

function GetHighestTeamSkillValue( team, skillName )
	local highestValue = 0
	for k, characterData in pairs( team.AssignedCharacters ) do
		local value = GetUnitSkillValue( characterData, skillName )
		if value > highestValue then
			highestValue = value
		end
	end
	return highestValue
end

function GetTotalTeamSkillValue( team, skillName )
	local totalValue = 0
	for k, characterData in pairs( team.AssignedCharacters ) do
		local value = GetUnitSkillValue( characterData, skillName )
		totalValue = totalValue + value
	end
	return totalValue
end

function AttemptPickSkill( skilledCharacter, newSkill )

	if skilledCharacter.SkillPoints == 0 then
		DisplayInfoPanelText({ Name = "Skills_InsufficientSkillPoints", Duration = 2.5 })
		return
	end

	PickSkill( skilledCharacter, newSkill )

end

function PickSkill( skilledCharacter, newSkill )

	PlaySound({ Name = "/SFX/Menu Sounds/SkillUpgradeConfirm" })
	Rumble({ RightFraction = 0.3, Duration = 0.3 })

	AddSkill( skilledCharacter, newSkill )

	if skilledCharacter.Level == 2 or skilledCharacter.Level == 5 then
		thread( SkillPickedAudio )
	end

	skilledCharacter.SkillPoints = skilledCharacter.SkillPoints - 1

	if skilledCharacter.SkillPoints > 0 then
		wait(0.2)
	else
		notifyExistingWaiters( "allSkillsPicked" )
	end

	notify( "skillsPicked" )

end

function AddSkill( skilledCharacter, newSkill )

	if newSkill == nil then
		return
	end

	NewSkillData = PlayerSkillsTable[newSkill]

	if NewSkillData ~= nil then
		if NewSkillData.GiveTrait then
			AddCharacterTrait( skilledCharacter, NewSkillData.GiveTrait )
		end
	end

	table.insert( skilledCharacter.Skills, newSkill )

end

function RemoveSkill( character, skillToRemove )
	if skillToRemove == nil then
		return
	end

	local didRemoveSkill = RemoveValueAndCollapse( character.Skills, skillToRemove )
	local removedSkillData = PlayerSkillsTable[skillToRemove]
	if removedSkillData ~= nil and removedSkillData.GiveTrait then
		SubtractCharacterTrait( character, removedSkillData.GiveTrait )
	end

	return didRemoveSkill

end

function SetupSkillLookups( character )

	character.SkillLookup = {}
	character.SkillValues = {}

	for k, skillName in pairs( character.Skills ) do

		local skillPrefix = StripChars( skillName, "1234567890" )
		local prefixLength = string.len( skillPrefix )
		local skillLevel = tonumber(string.sub( skillName, prefixLength + 1))
		character.SkillLookup[skillPrefix] = true
		if skillLevel ~= nil and skillLevel > 0 then
			if character.SkillValues[skillPrefix] == nil then
				character.SkillValues[skillPrefix] = skillLevel
			else
				character.SkillValues[skillPrefix] = character.SkillValues[skillPrefix] + skillLevel
			end
		end
	end

end

function ReloadMatchSkills()

	for teamIndex, team in pairs( League ) do
		for characterIndex, character in pairs( team.TeamBench ) do
			local characterData =  PlayerData.Teams[teamIndex].TeamBench[characterIndex]
			if characterData ~= nil then
				character.MatchSkills = characterData.MatchSkills
			end
		end
	end

end

function ReloadAttributes()

	for teamIndex, team in pairs( League ) do
		for characterIndex, character in pairs( team.TeamBench ) do
			local defaultAttributes = PlayerDefaultAttributes[character.Archetype]
			for attributeName, attributeValue in pairs( defaultAttributes ) do
				character[attributeName] = attributeValue
			end
		end
	end

end

OnTriggerFired{ "SkillPicked",
	function( triggerArgs )
		AttemptPickSkill( SelectedCharacter, triggerArgs.name )
	end
}

local skillsToDistribute =
{
	"TeamBallSkill", "TeamStaminaRechargeSkill",
}

local teamSkills =
{
	"TeamBallSkill", "TeamStaminaRechargeSkill",
	"BetterBeacon", "TauntSaplingExplode", "TeamEnemyBanishTime", "TeamReviveSkill",
	"TeamHeadWinds", "SoleUnitPowerUp", "AllDeadRespawnTeam", "PyreLastHitRegenerateTeam",
	"LosingScoreScoreDebuff", "LosingBallPosition",
}

function DistributeTeamSkills( team )

	for i, teamSkillName in pairs( teamSkills ) do
		for k, character in pairs( team.AssignedCharacters ) do
			if UnitHasSkill( character, teamSkillName ) then
				team.TeamSkills[teamSkillName] = true
			end
		end
	end

	for i, skillName in pairs( skillsToDistribute ) do
		if TeamHasSkillDrafted( team, skillName ) then
			for j, character in pairs( team.AssignedCharacters ) do
				if not UnitHasSkill( character, skillName ) then
					ApplyUpgrade({ Name = skillName, DestinationId = character.ObjectId })
				end
			end
		end
	end

end

function ApplyTeamSkills( team, objectId )

	for k, skillName in pairs( skillsToDistribute ) do
		if TeamHasSkillDrafted( team, skillName ) then
			ApplyUpgrade({ Name = skillName, DestinationId = objectId })
		end
	end

end

OnSpawn{ "DefenderUnit DefenderUnitMini",
	function( triggerArgs )

		local team = TeamA
		if triggerArgs.PlayerIndex == 1 then
			team = TeamB
		end
		ApplyTeamSkills( team, triggerArgs.triggeredById )

	end
}


function CheckPyreLastHitShield( team )

	if team.PyreShieldProcced then
		return
	end

	if team.PyreHealth >= 1 then
		return
	end

	local skillValue = GetTotalTeamSkillValue( team, "PyreLastHitShield" )
	if skillValue > 0 then
		team.PyreHealth = skillValue
		team.PyreShieldProcced = true
		thread( SkillProcFeedback, team.GoalButtonId, "MatchMessage_LastHitShield", nil, skillValue )
		thread( MeteoriteSlam, team.GoalButtonId, team.PyreId, 0.3 )
	end

end

SkillProcData =
{
	-- scoring
	["SacrificeScoreSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["ThrowScoreSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["PyreDamageSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["LosingScoreSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["WinningScoreSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["UniqueFlyingSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["AnyScoreSkill"] = { AppendText = "MatchMessage_Score", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },

	-- limited-time scoring - start of scoring window
	["BanishScoreBonus"] = { AppendText = "MatchMessage_ScoreLimited", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["TauntScoreSkillStart"] = { AppendText = "MatchMessage_ScoreLimited", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },

	-- score/pyre debuff
	["LosingScoreScoreDebuff"] = { AppendText = "MatchMessage_ScoreDebuff", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["PyrePreDamageSkill"] = { AppendText = "MatchMessage_PyreDebuff", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- pyre health
	["PyreHealthSkill"] = { AppendText = "MatchMessage_ScoreBuff", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },

	-- pyre restore
	["PyreLastHitShield"] = { AppendText = "MatchMessage_Heal", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["GoalHealSkill"] = { AppendText = "MatchMessage_Heal", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },
	["GoalLifeStealSkill"] = { AppendText = "MatchMessage_Heal", SFX = "/SFX/Match SFX/PositiveTalismanProc_2" },

	-- stamina refill
	["MonsterJumpSkill"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["KillsRegenerateStamina"] = { AppendText = "", SFX = "/SFX/Match SFX/StaminaSkillProc" },
	["MatchMessage_UnlimitedStamina"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" }, -- matchsiteC powerups
	["PowerShotKillSkill"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["BetterBeacon"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["SoleUnitPowerUp"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["PairPowerUp"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["StaminaOnBallPickupItem"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- speed buff
	["OnKillBuffSpeed"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- speed debuff
	["TeamHeadWinds"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_3" },

	-- special kill
	["AuraSpikeKill"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["JumpKillSkill"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- casting
	["MassivePowerShot"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- AOE bursts
	["CastExplosion"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["AuraKillDetonate"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- teleport
	["TauntBallTeleport"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["TauntSwap"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- curse
	["AuraWithBall"] = { AppendText = "MatchMessage_NoCast", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["TauntPolymorphSide"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },
	["TauntTimeout"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- exploded sapling
	["TauntSaplingExplodeMessage"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_1" },

	-- respawn
	["CastFastRespawn"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_3" },
	["QuickRespawnSkill"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_3" },
	["InstantRespawn"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_3" },
	["KillsRespawnFriends"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_3" },
	["JumpRespawn"] = { AppendText = "", SFX = "/SFX/Match SFX/PositiveTalismanProc_3" },
}


-- Constellation / Elective Difficulty --

ConstellationStarData =
{
	-- pyres
	-- Endriga the Widow
	["YourPyreDamaged"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = -1200, CenterOffsetY = -1000,
		Available = true,
		NewlyAvailable = true,
		MatchNumberUnlock = 7,
		DialogueLine = "/VO/Match_611",

		DifficultyStarGroup = "DS_Endriga",
		DifficultyStarOnGroup = "DS_EndrigaOn",
		DifficultyStarCentralStar = 314378,
		DifficultyStarCentralArt = 313819,

		NightSkyOldenStarGroup = "EndrigaStar",
		NightSkyTitanStarGroup = "Endriga",
		NightSkyOldenStarId = 313747,
		NightSkyOldenStarTooltip = "Star_EndrigaStar",
		NightSkyTitanStarId = 314377,
		NightSkyTitanStarTooltip = "Star_Endriga"
	},
	-- Archbeast Sung-Gries
	["RivalPyreHealth"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = -300, CenterOffsetY = -1000,
		Available = false,
		MatchNumberUnlock = 11,
		DialogueLine = "/VO/Match_621",

		DifficultyStarGroup = "DS_Archbeast",
		DifficultyStarOnGroup = "DS_ArchbeastOn",
		DifficultyStarCentralStar = 314360,
		DifficultyStarCentralArt = 314435,

		NightSkyOldenStarGroup = "ArchbeastStar",
		NightSkyTitanStarGroup = "ArchBeast",
		NightSkyOldenStarId = 314355,
		NightSkyOldenStarTooltip = "Star_ArchbeastStar",
		NightSkyTitanStarId = 314375,
		NightSkyTitanStarTooltip = "Star_Archbeast"
	},
	-- Bialanthius
	["RivalPyreDamage"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = 700, CenterOffsetY = -1000,
		Available = false,
		MatchNumberUnlock = 16,
		DialogueLine = "/VO/Match_613",

		DifficultyStarGroup = "DS_Bialanthius",
		DifficultyStarOnGroup = "DS_BialanthiusOn",
		DifficultyStarCentralStar = 314359,
		DifficultyStarCentralArt = 314170,

		NightSkyOldenStarGroup = "BialanthiusStar",
		NightSkyTitanStarGroup = "Bialanthius",
		NightSkyOldenStarId = 130107,
		NightSkyOldenStarTooltip = "Star_BialanthiusStar",
		NightSkyTitanStarId = 314174,
		NightSkyTitanStarTooltip = "Star_Bialanthius"
	},
	-- Dolnis the Locket
	["RivalPyreRegenerate"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = 1200, CenterOffsetY = -1000,
		Available = false,
		MatchNumberUnlock = 18,
		DialogueLine = "/VO/Match_610",

		DifficultyStarGroup = "DS_Dolnis",
		DifficultyStarOnGroup = "DS_DolnisOn",
		DifficultyStarCentralStar = 314363,
		DifficultyStarCentralArt = 314439,

		NightSkyOldenStarGroup = "DolnisStar",
		NightSkyTitanStarGroup = "Dolnis",
		NightSkyOldenStarId = 314356,
		NightSkyOldenStarTooltip = "Star_DolnisStar",
		NightSkyTitanStarId = 314371,
		NightSkyTitanStarTooltip = "Star_Dolnis"
	},

	-- passives
	-- Limbless Arizech
	["RivalTeamAttitude"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = 700, CenterOffsetY = -600,
		Available = true,
		NewlyAvailable = true,
		MatchNumberUnlock = 7,
		DialogueLine = "/VO/Match_616",

		DifficultyStarGroup = "DS_Arizech",
		DifficultyStarOnGroup = "DS_ArizechOn",
		DifficultyStarCentralStar = 314362,
		DifficultyStarCentralArt = 313810,

		NightSkyOldenStarGroup = "ArizechStar",
		NightSkyTitanStarGroup = "Arizech",
		NightSkyOldenStarId = 130103,
		NightSkyOldenStarTooltip = "Star_ArizechStar",
		NightSkyTitanStarId = 314374,
		NightSkyTitanStarTooltip = "Star_Arizech"
	},
	-- Lord Gandroth
	["RivalTeamAura"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = 700, CenterOffsetY = -200,
		Available = false,
		MatchNumberUnlock = 13,
		DialogueLine = "/VO/Match_618",

		DifficultyStarGroup = "DS_Gandroth",
		DifficultyStarOnGroup = "DS_GandrothOn",
		DifficultyStarCentralStar = 314432,
		DifficultyStarCentralArt = 314390,

		NightSkyOldenStarGroup = "GandrothStar",
		NightSkyTitanStarGroup = "Gandroth",
		NightSkyOldenStarId = 130104,
		NightSkyOldenStarTooltip = "Star_GandrothStar",
		NightSkyTitanStarId = 314212,
		NightSkyTitanStarTooltip = "Star_Gandroth"
	},
	-- Unfathomed Plurnes
	["RivalTeamSpeed"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = 700, CenterOffsetY = 200,
		Available = false,
		MatchNumberUnlock = 12,
		DialogueLine = "/VO/Match_617",

		DifficultyStarGroup = "DS_Plurnes",
		DifficultyStarOnGroup = "DS_PlurnesOn",
		DifficultyStarCentralStar = 314470,
		DifficultyStarCentralArt = 314446,

		NightSkyOldenStarGroup = "PlurnesStar",
		NightSkyTitanStarGroup = "Plurnes",
		NightSkyOldenStarId = 314331,
		NightSkyOldenStarTooltip = "Star_PlurnesStar",
		NightSkyTitanStarId = 314364,
		NightSkyTitanStarTooltip = "Star_Plurnes"
	},
	-- Time-Singer Harn
	["RivalTeamStamina"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = 700, CenterOffsetY = 600,
		Available = false,
		MatchNumberUnlock = 14,
		DialogueLine = "/VO/Match_619",

		DifficultyStarGroup = "DS_Harn",
		DifficultyStarOnGroup = "DS_HarnOn",
		DifficultyStarCentralStar = 314469,
		DifficultyStarCentralArt = 314392,

		NightSkyOldenStarGroup = "HarnStar",
		NightSkyTitanStarGroup = "Harn",
		NightSkyOldenStarId = 314353,
		NightSkyOldenStarTooltip = "Star_HarnStar",
		NightSkyTitanStarId = 314365,
		NightSkyTitanStarTooltip = "Star_Harn"
	},

	-- match performance
	-- Yslach Astral-Born
	["RivalTeamAI"] =
	{
		StarId = nil, XPBonus = 0.10,
		CenterOffsetX = -700, CenterOffsetY = -600,
		Available = true,
		NewlyAvailable = true,
		MatchNumberUnlock = 7,
		DialogueLine = "/VO/Match_620",

		DifficultyStarGroup = "DS_Yslach",
		DifficultyStarOnGroup = "DS_YslachOn",
		DifficultyStarCentralStar = 314475,
		DifficultyStarCentralArt = 313893,

		NightSkyOldenStarGroup = "YslachStar",
		NightSkyTitanStarGroup = "Yslach",
		NightSkyOldenStarId = 313708,
		NightSkyOldenStarTooltip = "Star_YslachStar",
		NightSkyTitanStarId = 314367,
		NightSkyTitanStarTooltip = "Star_Yslach"
	},
	-- Xilvias Horse-Headed
	["RivalTeamSacrificeRespawn"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = -700, CenterOffsetY = -200,
		Available = false,
		MatchNumberUnlock = 15,
		DialogueLine = "/VO/Match_615",

		DifficultyStarGroup = "DS_Xilvias",
		DifficultyStarOnGroup = "DS_XilviasOn",
		DifficultyStarCentralStar = 314474,
		DifficultyStarCentralArt = 314175,

		NightSkyOldenStarGroup = "XilviasStar",
		NightSkyTitanStarGroup = "Xilvias",
		NightSkyOldenStarId = 130106,
		NightSkyOldenStarTooltip = "Star_XilviasStar",
		NightSkyTitanStarId = 314369,
		NightSkyTitanStarTooltip = "Star_Xilvias"
	},
	-- The Tattered Mantle
	["RivalTeamPassOnDeath"] =
	{
		StarId = nil, XPBonus = 0.03,
		CenterOffsetX = -700, CenterOffsetY = 200,
		Available = false,
		MatchNumberUnlock = 19,
		DialogueLine = "/VO/Match_614",

		DifficultyStarGroup = "DS_Mantle",
		DifficultyStarOnGroup = "DS_MantleOn",
		DifficultyStarCentralStar = 314471,
		DifficultyStarCentralArt = 190017,

		NightSkyOldenStarGroup = "MantleStar",
		NightSkyTitanStarGroup = "Mantle",
		NightSkyOldenStarId = 314329,
		NightSkyOldenStarTooltip = "Star_MantleStar",
		NightSkyTitanStarId = 314214,
		NightSkyTitanStarTooltip = "Star_Mantle"
	},
	-- Shax Six Shoulders
	["RivalTeamReturnFromBanishment"] =
	{
		StarId = nil, XPBonus = 0.10,
		CenterOffsetX = -700, CenterOffsetY = 600,
		Available = false,
		MatchNumberUnlock = 17,
		DialogueLine = "/VO/Match_612",

		DifficultyStarGroup = "DS_Shax",
		DifficultyStarOnGroup = "DS_ShaxOn",
		DifficultyStarCentralStar = 314473,
		DifficultyStarCentralArt = 314434,

		NightSkyOldenStarGroup = "ShaxStar",
		NightSkyTitanStarGroup = "Shax",
		NightSkyOldenStarId = 130105,
		NightSkyOldenStarTooltip = "Star_ShaxStar",
		NightSkyTitanStarId = 314368,
		NightSkyTitanStarTooltip = "Star_Shax"
	},
}

function ReloadConstellationStars( missingOnly )

	if ConstellationStars == nil then
		return
	end

	-- @todo Generalize all of these
	for starName, savedStar in pairs( ConstellationStars ) do
		local starData = ConstellationStarData[starName]
		for key, value in pairs( starData ) do
			if not missingOnly or savedStar[key] == nil then
				if type(value) == "table" then
					savedStar[key] = ShallowCopyTable( value )
				else
					savedStar[key] = value
				end
			end
		end
	end
end

function SetupConstellationInput()
	SetConfigOption({ Name = "GamepadCursorControl", Value = true })
	if GetConfigOptionValue({ Name = "UseMouse" }) then

		DebugPrint({ Text = "Constellation Input: Mouse" })
		TeleportCursor({ OffsetX = 960, OffsetY = 540 })
		SetConfigOption({ Name = "CameraEdgePanSpeed", Value = 3000 })
		SetConfigOption({ Name = "CameraEdgePanThreshold", Value = 200 })

	else
		DebugPrint({ Text = "Constellation Input: Gamepad" })
		TeleportCursor({ OffsetX = 960, OffsetY = 540 })
		SetConfigOption({ Name = "CameraFollowCursor", Value = 1500 })
		SetConfigOption({ Name = "GamepadCursorSpeed", Value = "Default" })
	end

	local clampA = SpawnObstacle({ Name = "InvisibleTarget", Group = "Scripting", DestinationName = "Player" })
	local clampB = SpawnObstacle({ Name = "InvisibleTarget", Group = "Scripting", DestinationName = "Player" })
	if StarAlignmentLocations ~= nil then
		Teleport({ Id = clampA, DestinationId = StarAlignmentLocations[currentNodeId], OffsetX = -2600, OffsetY = -2000 })
		Teleport({ Id = clampB, DestinationId = StarAlignmentLocations[currentNodeId], OffsetX = 1900, OffsetY = 900 })
	end
	SetCameraClamp({ Ids = { clampA, clampB }, SoftClamp = 0.1, LerpTime = 1.0 })
end

moonGlowsA = { 215479 }
moonGlowsB = { 215429 }
moonExit = 215429

function SetupAscensionSky()
	SetGroupVisibility({ Name = "AscensionSkyTop", Visible = false })
	SetGroupVisibility({ Name = "AscensionSkyBot", Visible = false })
	SetOpacity({ Names = { "AscensionSkyTop", "AscensionSkyBot" }, Fraction = 0 })
end

function SetupConstellationVisuals( centerPoint )

	SetGroupVisibility({ Names = TitanStarGroups, Visible = true })
	SetupAscensionSky()

	if centerPoint ~= nil then
		Teleport({ Names = TitanStarGroups, KeepRelativeOffsets = true, IgnoreChildren = true, DestinationId = centerPoint, RelativeOffsetId = 314476, OffsetY = -220 })
		if not inMatch then
			InsertGroupInFront({ Names = TitanStarGroups, DestinationName = "Swath_0"..currentlyOccupiedSwath.."_DayNight" })
		end
	end

	local opacityOffGroups = {}
	local moonSigils = { 215480 }
	for starName, starData in pairs( ConstellationStars ) do
		table.insert( opacityOffGroups, starData.DifficultyStarGroup )
		table.insert( opacityOffGroups, starData.DifficultyStarOnGroup )
	end
	SetOpacity({ Names = opacityOffGroups, Ids = moonSigils, Fraction = 0 })

end

local constellationOpacityAvailable = 0.35

function CreateConstellations()

	if not CanShowConstellations() then
		return
	end

	enlightenmentBonus = enlightenmentBonus or 0

	-- display useable star buttons
	local starTraceIds = { }
	local matchOffsetXModifer = 0
	local matchOffsetYModifer = 0
	if inMatch then
		matchOffsetXModifer = -100
		matchOffsetYModifer = -200
	end

	AdjustColorGrading({ Name = "MeteorStrike", Duration = 0.1 })
	if SpecialOvermapColorGrade then
		AdjustColorGrading({ Name = "Off", Duration = 1.0, Delay = 0.1 })
		AdjustFullscreenBloom({ Name = "Off", Duration = 1.0 })
		--AdjustColorGrading({ Name = SpecialOvermapColorGrade, Duration = 1.5, Delay = 0.2 })
	else
		AdjustColorGrading({ Name = "Off", Duration = 1.5, Delay = 0.2 })
	end

	FireTrigger({ Name = "StartConstellationMusic" })
	PlaySound({ Name = "/SFX/Leftovers/TextReveal" })

	UpdateTotalEnlightenmentBonus()

	for starName, starData in pairs( ConstellationStars ) do

		local destinationStar = starData.DifficultyStarCentralStar

		local starLabelColor = Color.LightBlue

		local tooltipKey = starName
		if starData.Status == "On" then
			tooltipKey = starName.."_Alt"
		end
		if TotalEnlightenmentBonus == 0 and not IsMultiplayerMatch() then
			tooltipKey = starName.."_Initial"
		end
		if IsMultiplayerConstellations() then
			tooltipKey = tooltipKey.."_LocalMP"
			if starName == "RivalTeamAI" and head2head then
				tooltipKey = tooltipKey.."_2Player"
			end
		end

		if starData.Available then
			UseableOn({ Id = destinationStar })

			SetGroupVisibility({ Name = starData.DifficultyStarGroup, Visible = true })
			AddToGroup({ Id = starData.DifficultyStarCentralStar, Name = "ConstellationStars" })

			SetInteractProperty({ DestinationId = starData.DifficultyStarCentralArt, Name = "TooltipId", Value = tooltipKey })
			SetInteractProperty({ DestinationId = starData.DifficultyStarCentralStar, Name = "TooltipId", Value = tooltipKey })

			SetOpacity({ Name = starData.DifficultyStarGroup, Fraction = 1.0, Duration = 0.1 })
			SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = constellationOpacityAvailable, Duration = 0.1 })
			SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = constellationOpacityAvailable, Duration = 0.1 })

		else
			UseableOff({ Id = destinationStar })
			SetGroupVisibility({ Name = starData.DifficultyStarGroup, Visible = false })
		end

		if starData.Status == "On" then
			SetGroupVisibility({ Name = starData.DifficultyStarOnGroup, Visible = true })
			SetColor({ Id = starData.DifficultyStarCentralArt, Color = { 255,  74, 131, 255 } })
			SetColor({ Id = starData.DifficultyStarCentralStar, Color = { 255,  74, 131, 255 } })

			starLabelColor = Color.Gold
			starData.EnlightenmentBonus = starData.XPBonus * 100

			SetOpacity({ Name = starData.DifficultyStarOnGroup, Fraction = 1.0, Duration = 0.1 })
			SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = 1.0, Duration = 0.1 })
			SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = 1.0, Duration = 0.1 })
		else
			SetGroupVisibility({ Name = starData.DifficultyStarOnGroup, Visible = false })
			SetColor({ Id = starData.DifficultyStarCentralArt, Color = Color.White })
			SetColor({ Id = starData.DifficultyStarCentralStar, Color = Color.White })
			SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = constellationOpacityAvailable, Duration = 0.1 })
			SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = constellationOpacityAvailable, Duration = 0.1 })

			starData.EnlightenmentBonus = 0
		end

		if starData.NewlyAvailable ~= nil and starData.NewlyAvailable then
			starData.NewlyAvailable = false
			if not inMatch then
				SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = 1.0, Duration = 0.1 })
				PlayOverheadAnimation({ Name = "WagonNewItemSparkles", DestinationId = destinationStar, Scale = 1.5, IgnoreOverheadOffset = true, Color = { 255,  74, 131, 255 }, })
				PlayOverheadAnimation({ Name = "WagonNewItemSparkles", DestinationId = destinationStar, Scale = 1.0, IgnoreOverheadOffset = true, Color = { 255,  255, 255, 255 }, OffsetX = -5, OffsetY = 15 })
				PlayOverheadAnimation({ Name = "WagonNewItemSparkles", DestinationId = destinationStar, Scale = 0.8, IgnoreOverheadOffset = true, Color = { 255,  255, 255, 255 }, OffsetX = 15, OffsetY = -5 })
				if not playedStarAppearedSound then
					playedStarAppearedSound = true
					PlaySound({ Name = "/SFX/Match SFX/GoalScored", Delay = 0.0 })
				end
			end
		end
	end

	if inMatch then
		HideUnusedConstellations()
		FadeAllConstellations( 0.0001 )
	end

	wait(0.1)

	if IsMultiplayerMatch() then
		SetInteractProperty({ DestinationId = moonExit, Name = "TooltipId", Value = "DifficultyScreen_Confirm" })
	else
		SetInteractProperty({ DestinationId = moonExit, Name = "TooltipId", Value = "DifficultyScreen_Confirm_Campaign" })
	end

	-- context events
	-- Titan Stars intro special case
	if not IsMultiplayerMatch() then
		if not NarrationRecord["DifficultyModifiers_01"] then
			wait(3.5)
			NarrationSequenceOnce( "DifficultyModifiers_01" )
			thread( DifficultyModifiersIntroAudio )
			wait(1.0)
		end
		if not IsEmpty( NextTeam["RivalryMatchConstellationEvents"] ) and IsRivalryPresent() and not IsAscensionWeek() then
			eventName = RemoveFirstIndexValue( NextTeam["RivalryMatchConstellationEvents"] )
			wait(2.0)
			NarrationSequence( eventName )
		end
	end

	thread( HideInputDisabledPresentation )
	EnableInput({  })
	SetConfigOption({ Name = "GamepadCursorControl", Value = true })
	constellationPick = true
	waitUntil("ContinueFromConstellations")
	if inMatch then
		SetConfigOption({ Name = "GamepadCursorControl", Value = false })
	end
	FireTrigger({ Name = "EndConstellationMusic" })
	constellationPick = false
	thread( ShowInputDisabledPresentation )
	--AdjustColorGrading({ Name = "Night50", Duration = 1.0 })
	RemoveConstellations( starTraceIds )
end

function CanShowConstellations()

	if IsMultiplayerMatch() then
		if IsMultiplayerConstellations() then
			return true
		else
			return false
		end
	end

	if practiceMatch then
		return false
	end

	if not allowCaravanFly then
		return false
	end

	-- Open Structure: when Difficulty Modifiers are first introduced
	if PlayerTeam.AscensionMatchesPlayed == 1 and MatchesPlayedThisSeason < 2 then
		return false
	end

	return true

end

function FadeUnusedConstellations( fadeTime )
	for starName, starData in pairs( ConstellationStars ) do
		if starData.Status ~= "On" then
			SetOpacity({ Name = starData.DifficultyStarOnGroup, Fraction = 0.0, Duration = fadeTime })
			SetOpacity({ Name = starData.DifficultyStarGroup, Fraction = 0.0, Duration = fadeTime })
			SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = 0.0, Duration = fadeTime })
			SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = 0.0, Duration = fadeTime })
		end
	end
end

function HideUnusedConstellations()
	for starName, starData in pairs( ConstellationStars ) do
		if starData.Status ~= "On" then
			SetGroupVisibility({ Name = starData.DifficultyStarOnGroup, Visible = false })
			SetGroupVisibility({ Name = starData.DifficultyStarGroup, Visible = false })
		end
	end
end

function FadeAllConstellations( fadeTime )
	for starName, starData in pairs( ConstellationStars ) do
		SetOpacity({ Name = starData.DifficultyStarOnGroup, Fraction = 0.0, Duration = fadeTime })
		SetOpacity({ Name = starData.DifficultyStarGroup, Fraction = 0.0, Duration = fadeTime })
		SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = 0.0, Duration = fadeTime })
		SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = 0.0, Duration = fadeTime })
	end
end

OnMouseOver{ "DS_Moon01",
	function(triggerArgs)
		MoonHighlightOn()
	end
}

OnMouseOff{ "DS_Moon01",
	function(triggerArgs)
		MoonHighlightOff()
	end
}

function MoonHighlightOn()
	SetColor({ Ids = moonGlowsA, Color = { 255, 5, 105, 153 }, Override = true, Duration = 0.1 })
end

function MoonHighlightOff()
	SetColor({ Ids = moonGlowsA, Color = { 5, 205, 255, 153 }, Override = true, Duration = 0.1 })
end

OnMouseOver{ "ConstellationStars DS_Archbeast DS_Arizech DS_Bialanthius DS_Dolnis DS_Endriga DS_Gandroth DS_Harn DS_Mantle DS_Plurnes DS_Shax DS_Xilvias DS_Yslach",
	function(triggerArgs)
		for k, starData in pairs( ConstellationStars ) do
			if starData.DifficultyStarCentralArt == triggerArgs.triggeredById or starData.DifficultyStarCentralStar == triggerArgs.triggeredById then
				StopAnimation({ Name = "WagonNewItemSparkles", DestinationId = starData.DifficultyStarCentralStar })
				SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = 1.0, Duration = 0.1 })
				SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = 1.0, Duration = 0.1 })
			end
		end
	end
}

OnMouseOff{ "ConstellationStars DS_Archbeast DS_Arizech DS_Bialanthius DS_Dolnis DS_Endriga DS_Gandroth DS_Harn DS_Mantle DS_Plurnes DS_Shax DS_Xilvias DS_Yslach",
	function(triggerArgs)
		for k, starData in pairs( ConstellationStars ) do
			if starData.DifficultyStarCentralArt == triggerArgs.triggeredById or starData.DifficultyStarCentralStar == triggerArgs.triggeredById then
				if starData.Status ~= "On" then
					SetOpacity({ Id = starData.DifficultyStarCentralArt, Fraction = constellationOpacityAvailable, Duration = 0.1 })
					SetOpacity({ Id = starData.DifficultyStarCentralStar, Fraction = constellationOpacityAvailable, Duration = 0.1 })
				end
			end
		end
	end
}

OnUsed{ "ConstellationStars DS_Moon01 DS_Archbeast DS_Arizech DS_Bialanthius DS_Dolnis DS_Endriga DS_Gandroth DS_Harn DS_Mantle DS_Plurnes DS_Shax DS_Xilvias DS_Yslach",
	function(triggerArgs)
		if not constellationPick then
			return
		end
		if triggerArgs.triggeredById == moonExit then
			ConstellationPicksExit()
		else
			HandleConstellationToggle(triggerArgs.triggeredById)
		end
	end
}

OnControlPressed{ "Confirm",
	function(triggerArgs)
		if not constellationPick then
			return
		end
		if not IsInputAllowed({ }) then
			return
		end
		ConstellationPicksExit()
	end
}

function ConstellationPicksExit()

	DisableInput({  })
	MoonHighlightOff()
	RemoveWorldText({ DestinationId = moonExit, Duration = 0.15 })
	FadeUnusedConstellations( 0.5 )
	if IsAnyConstellationActive() then
		PlaySound({ Name = "/SFX/Menu Sounds/GuideBookChapterUnlock" })
		-- VO: Difficulty Modifier confirmations
		if starToggled and not IsMultiplayerMatch() then
			if AreAllConstellationsActive() then
				thread( DifficultyModifiersAllChosenAudio )
			else
				-- thread( DifficultyModifiersSomeChosenAudio )
			end
		end
	else
		PlaySound({ Name = "/SFX/Match SFX/AuraOnLoud" })
	end
	FireTrigger({ Name = "EndConstellationMusic" })
	ModifyConstellationStats()
	-- remove record of star toggle VO having played
	for starName, starData in pairs( ConstellationStars ) do
		SpeechRecord[starData.DialogueLine] = nil
		starData.DialogueLinePlayed = nil
	end
	notifyExistingWaiters("ContinueFromConstellations")

end

function ConstellationsModifyPyres()

	-- pyre pre-damage modifier
	if ConstellationActive( "YourPyreDamaged") then
		TeamA.PyreHealth = TeamA.PyreHealth - 30
		if TeamA.PyreHealth < 1 then
			TeamA.PyreHealth = 1
		end
		UpdatePyreScale( TeamA )
	end

	-- pyre pre-health modifier
	if ConstellationActive( "RivalPyreHealth") then
		local team = TeamB
		team.PyreMaxHealth = team.PyreMaxHealth + 30
		team.PyreHealth = team.PyreHealth + 30
		UpdatePyreScale( team )
	end

end

function ModifyConstellationStats()

	for index, character in pairs( NextTeam.TeamBench ) do

		if ConstellationActive("RivalTeamAttitude") then
			ModifyAttributeTemporarily( character, "PlayerAttributeRespawn", 8, "RivalTeamAttitude" )
		end
		if ConstellationActive("RivalTeamAura") then
			ModifyAttributeTemporarily( character, "PlayerAttributeAura", 8, "RivalTeamAura" )
		end
		if ConstellationActive("RivalTeamSpeed") then
			ModifyAttributeTemporarily( character, "PlayerAttributeSpeed", 8, "RivalTeamSpeed" )
		end

	end

end

function HandleConstellationToggle( toggledStarId )
	for k, starData in pairs( ConstellationStars ) do
		if starData.CurrentStarId == toggledStarId or starData.DifficultyStarCentralArt == toggledStarId or starData.DifficultyStarCentralStar == toggledStarId then
			if starData.Status == nil or starData.Status == "Off" then
				-- flag for use with some VO; checking to see if played interacted with the stars, vs. holding over from last time
				starToggled = true
				starData.Status = "On"
				starData.EnlightenmentBonus = starData.XPBonus * 100
				UpdateTotalEnlightenmentBonus()
				CheckInitialConstellationTooltips()

				SetGroupVisibility({ Name = starData.DifficultyStarOnGroup, Visible = true })
				SetRed({ Id = starData.DifficultyStarCentralArt, Fraction = 1.0, Duration = 0.2 })
				SetGreen({ Id = starData.DifficultyStarCentralArt, Fraction = 0.29, Duration = 0.2 })
				SetBlue({ Id = starData.DifficultyStarCentralArt, Fraction = 0.51, Duration = 0.2 })
				SetRed({ Id = starData.DifficultyStarCentralStar, Fraction = 1.0, Duration = 0.2 })
				SetGreen({ Id = starData.DifficultyStarCentralStar, Fraction = 0.29, Duration = 0.2 })
				SetBlue({ Id = starData.DifficultyStarCentralStar, Fraction = 0.51, Duration = 0.2 })
				--SetColor({ Id = starData.DifficultyStarCentralArt, Color = { 255, 74, 131, 255 }, Duration = 0.2 })
				--SetColor({ Id = starData.DifficultyStarCentralStar, Color = { 255, 74, 131, 255 }, Duration = 0.2 })

				PlaySound({ Name = "/SFX/Menu Sounds/TitanToggleLong" })
				if starData.DialogueLine ~= nil and not starData.DialogueLinePlayed then
					PlaySpeech({ Name = starData.DialogueLine })
					-- following prevents VO for a given star repeating this session; is later cleared
					if SpeechRecord[starData.DialogueLine] then
						starData.DialogueLinePlayed = true
					end
				end
				local tooltipKey = k.."_Alt"
				if IsMultiplayerConstellations() then
					tooltipKey = tooltipKey.."_LocalMP"
					if k == "RivalTeamAI" and head2head then
						tooltipKey = tooltipKey.."_2Player"
					end
				end
				SetInteractProperty({ DestinationId = starData.DifficultyStarCentralArt, Name = "TooltipId", Value = tooltipKey })
				SetInteractProperty({ DestinationId = starData.DifficultyStarCentralStar, Name = "TooltipId", Value = tooltipKey })
				--UpdateWorldText({ Text = k, Id = starData.CurrentStarId, TooltipKey = tooltipKey, TooltipData = starData, Color = Color.Gold })
			elseif starData.Status == "On" then
				starData.Status = "Off"
				starData.EnlightenmentBonus = 0
				UpdateTotalEnlightenmentBonus()
				CheckInitialConstellationTooltips()
				--SetColor({ Id =  starData.CurrentStarId, Color = Color.LightBlue })
				StopAnimation({ DestinationId = starData.CurrentStarId, Name = "StarNodeActiveStreakSpawner", Scale = 2.0 })
				--SetScale({ Id = starData.CurrentStarId, Fraction = 1 })

				SetGroupVisibility({ Name = starData.DifficultyStarOnGroup, Visible = false })
				SetRGB({ Id = starData.DifficultyStarCentralArt, Fraction = 1.0, Duration = 0.2 })
				SetRGB({ Id = starData.DifficultyStarCentralStar, Fraction = 1.0, Duration = 0.2 })

				PlaySound({ Name = "/SFX/Menu Sounds/TitanToggleShort" })
				local tooltipKey = k
				if TotalEnlightenmentBonus == 0 and not IsMultiplayerMatch() then
					tooltipKey = k.."_Initial"
				end
				if IsMultiplayerConstellations() then
					tooltipKey = tooltipKey.."_LocalMP"
					if k == "RivalTeamAI" and head2head then
						tooltipKey = tooltipKey.."_2Player"
					end
				end
				SetInteractProperty({ DestinationId = starData.DifficultyStarCentralArt, Name = "TooltipId", Value = tooltipKey })
				SetInteractProperty({ DestinationId = starData.DifficultyStarCentralStar, Name = "TooltipId", Value = tooltipKey })
				--UpdateWorldText({ Text = k, Id = starData.CurrentStarId, TooltipKey = tooltipKey, TooltipData = starData, Color = Color.LightBlue })
			end
		end
	end
end

function UpdateTotalEnlightenmentBonus()
	local xpBonus = 0
	for k, modifierData in pairs( ConstellationStars ) do
		if modifierData.Status == "On" then
			xpBonus = xpBonus + modifierData.XPBonus
		end
	end
	TotalEnlightenmentBonus = xpBonus * 100
	PersistVariable({ Name = "TotalEnlightenmentBonus" })
	return xpBonus
end

function CheckInitialConstellationTooltips()
	if IsMultiplayerMatch() then
		return
	end
	for k, starData in pairs( ConstellationStars ) do
		if TotalEnlightenmentBonus == 0 then
			tooltipKey = k.."_Initial"
		elseif starData.Status == "On" then
			tooltipKey = k.."_Alt"
		else
			tooltipKey = k
		end
		SetInteractProperty({ DestinationId = starData.DifficultyStarCentralArt, Name = "TooltipId", Value = tooltipKey })
		SetInteractProperty({ DestinationId = starData.DifficultyStarCentralStar, Name = "TooltipId", Value = tooltipKey })
	end
end

function RemoveConstellations( starTraceIds, delay )
	if delay ~= nil then
		wait(delay)
	end

	StopUnattachedAnimations({ Animation = "StarConnector", PreventChain = true })
	StopUnattachedAnimations({ Animation = "StarConnectorLoop", PreventChain = true })

	StopAnimation({ Name = "StarNodeActiveStreakSpawner", DestinationName = "ConstellationStars" })

	RemoveWorldText({ DestinationName = "ConstellationStars", Duration = 0.3 })
	SetOpacity({ Id = exitStar, Duration = 0.2, Fraction = 0 })
	Delete({ Id = exitStar, Delay = 0.3 })
	local starMapIds = GetIds({ Name = "ConstellationStars" })
	RemoveWorldText({ DestinationIds = starMapIds, Duration = 0.3 })
	Delete({ Ids = starTraceIds })
end

function IsAnyConstellationActive()

	if practiceMatch then
		return false
	end

	for k, modifierData in pairs( ConstellationStars ) do
		if modifierData.Status == "On" then
			return true
		end
	end

	return false

end

function AreAllConstellationsActive()

	if practiceMatch then
		return false
	end

	local constellationsActive = 0
	local constellationsInactive = 0

	for k, modifierData in pairs( ConstellationStars ) do
		if modifierData.Status == "On" then
			constellationsActive = constellationsActive + 1
		else
			constellationsInactive = constellationsInactive + 1
		end
	end

	-- for checking no constellations are inactive
	-- if constellationsInactive == 0 then
	-- for checking if all 12 constellations are active
	if constellationsActive == 12 then
		return true
	else
		return false
	end

end

function CountConstellationsActive()
	local constellationsActive = 0
	for k, modifierData in pairs( ConstellationStars ) do
		if modifierData.Status == "On" then
			constellationsActive = constellationsActive + 1
		end
	end
	return constellationsActive
end

function CheckConstellationAchievement()

	if practiceMatch then
		return
	end

	if GetConfigOptionValue({ Name = "CampaignDifficulty" }) == "Campaign_Easy" then
		return
	end

	local constellationsActive = CountConstellationsActive()
	if constellationsActive >= 3 then
		UnlockAchievementOnce( "AchConstellations3" )
	end
	if constellationsActive >= 6 then
		UnlockAchievementOnce( "AchConstellations6" )
	end
	if constellationsActive >= 12 then
		UnlockAchievementOnce( "AchConstellationsAll" )
	end
end

function ConstellationActive( type )

	if practiceMatch then
		return false
	end

	if IsMultiplayerMatch() and not IsMultiplayerConstellations() then
		return false
	end

	for modifierName, modifierData in pairs( ConstellationStars ) do
		if modifierName == type and modifierData.Status == "On" then
			return true
		end
	end

	return false

end

function UnlockConstellation( name )
	local star = ConstellationStars[name]
	if star.Available then
		-- Already unlocked
		return
	end
	star.Available = true
	star.NewlyAvailable = true
end

function CheckConstellationUnlocks()

	if ConstellationStars == nil then
		return
	end

	for modifierName, modifierData in pairs( ConstellationStars ) do
		if modifierData.MatchNumberUnlock ~= nil and matchesPlayed >= modifierData.MatchNumberUnlock then
			UnlockConstellation( modifierName )
		end
	end

end

function ModifyAllPlayerCharactersAttribute( attributeName )
	for k, character in pairs( PlayerTeam.TeamBench ) do
		ModifyAttributeTemporarily( character, attributeName, 1, "StudyBonus_"..attributeName, true )
	end
end

function ModifyAttribute( character, attributeName, attributeAmount )

	if attributeName == "All" then
		local allAttributes = { "PlayerAttributeRespawn", "PlayerAttributeSpeed", "PlayerAttributeAura", }
		for k, subAttributeName in pairs( allAttributes ) do
			ModifyAttribute( character, subAttributeName, attributeAmount )
		end
		return
	end

	if character[attributeName] == nil then
		-- An NPC or other character who does not have this stat
		return
	end

	character[attributeName] = character[attributeName] + attributeAmount
	UpdateObjectiveTypeProgress( "StatValue", attributeName, character, character[attributeName] )
	UpdateTooltips( character )
	UpdateDerivedAttributes( character )
end

function ModifyAttributeReverse( character, attributeName, attributeAmount )

	if attributeName == "All" then
		local allAttributes = { "PlayerAttributeRespawn", "PlayerAttributeSpeed", "PlayerAttributeAura", }
		for k, subAttributeName in pairs( allAttributes ) do
			ModifyAttributeReverse( character, subAttributeName, attributeAmount )
		end
		return
	end

	if character[attributeName] == nil then
		-- An NPC or other character who does not have this stat
		return
	end

	character[attributeName] = character[attributeName] - attributeAmount
	UpdateObjectiveTypeProgress( "StatValue", attributeName, character, character[attributeName] )
	UpdateTooltips( character )
	UpdateDerivedAttributes( character )
end

function ModifyAttributeTemporarily( character, attributeName, attributeAmount, reason, permanent )

	statBonus = attributeAmount

	ModifyAttribute( character, attributeName, attributeAmount )

	if TempAttributeModifications == nil then
		TempAttributeModifications = {}
		PersistVariable({ Name = "TempAttributeModifications" })
	end

	if character.Id == nil then
		character.Id = character.FirstName or character.ShortName
	end
	if TempAttributeModifications[character.Id] == nil then
		TempAttributeModifications[character.Id] = {}
	end

	local attributeModification = TempAttributeModifications[character.Id][reason]
	if attributeModification == nil then
		attributeModification = { TeamIndex = character.TeamIndex, CharacterIndex = character.CharacterIndex, Name = attributeName, Amount = attributeAmount, Reason = reason, Permanent = permanent }
	else
		attributeModification.Amount = attributeModification.Amount + attributeAmount
	end
	TempAttributeModifications[character.Id][reason] = attributeModification

end

function RemoveAttributeModification( character, reason )

	if TempAttributeModifications == nil then
		return
	end

	local attributeModificationsForChar = TempAttributeModifications[character.Id]
	if attributeModificationsForChar ~= nil then
		local attributeModification = attributeModificationsForChar[reason]
		if attributeModification ~= nil then
			ModifyAttributeReverse( character, attributeModification.Name, attributeModification.Amount )
		end
		attributeModificationsForChar[reason] = nil
	end
end

function RestoreAttributes()

	if TempAttributeModifications == nil then
		return
	end

	for characterName, attributeModifications in pairs( TempAttributeModifications ) do
		for k, attributeModification in pairs( attributeModifications ) do
			if attributeModification ~= nil and not attributeModification.Permanent then
				if attributeModification.TeamIndex ~= nil and attributeModification.CharacterIndex ~= nil then
					local character = League[attributeModification.TeamIndex].TeamBench[attributeModification.CharacterIndex]
					ModifyAttributeReverse( character, attributeModification.Name, attributeModification.Amount )
				end
				RemoveValue( attributeModifications, attributeModification )
			end
		end
	end

end